; $Id: dcs_str_shorthand.pro,v 1.2 2002/07/13 20:30:59 john Exp $
; Written by J.R.D. Copley.
;************************************************************************************************
function dcs_str_shorthand,instr
;************************************************************************************************
;
compile_opt strictarr
;
; This routine takes a comma-delimited list of detectors and converts it into a more compact form.
; For example if instr='1,2,3,7,8,9,10,144,145,146,456' the function returns '1-3,7-10,144-146,456'
;
if (instr eq '') then return,instr
ints=fix(strsplit(instr,',',/extract))
nints=n_elements(ints)
kstrt=0
n=1
outstr=''
for k=1,nints-1 do begin
	if (ints[k] eq ints[kstrt]+n) then n=n+1 else begin
		outstr=outstr+strcompress(ints[kstrt],/remove_all)
		kend=k-1
		if (kstrt ne kend) then outstr=outstr+'-'+strcompress(ints[kend],/remove_all)
		outstr=outstr+','
		kstrt=k
		n=1
	endelse
endfor
outstr=outstr+strcompress(ints[kstrt],/remove_all)
kend=nints-1
if (kstrt ne kend) then outstr=outstr+'-'+strcompress(ints[kend],/remove_all)
return,outstr
end
