; $Id: dm_load_spe.pro,v 1.4.2.2 2004/05/28 17:52:01 azuah Exp $

; load spe file returns zdat[nx,ny], err[nx,ny], xdat[nx], ydat[ny]
pro dm_load_spe,unit,zdat=zdat,err=err,xdat=xdat,ydat=ydat
    nx = 0L & ny = 0L &junk=' ' &temp1=' '
    readf,unit,nx,ny
    zdat = fltarr(nx,ny)
    err  = fltarr(nx,ny)
    xdat = fltarr(nx+1)
    ydat = fltarr(ny+1)
    readf,unit,junk    ;read ### phi grid
    ;readf,unit,tth
    for i=0L,(nx+8)/8-1 do begin
       readf,unit,junk
       for j=0,7 do begin
         temp1=strmid(junk,10*j,10)
         if strlen(temp1) eq 0 then break
         xdat[8*i+j]=dm_to_number(temp1)
       endfor
    endfor
    readf,unit,junk    ;read ### Energy Grid
    ;readf,unit,en
    for i=0L,(ny+8)/8-1 do begin
       readf,unit,junk
       for j=0,7 do begin
         temp1=strmid(junk,10*j,10)
         if strlen(temp1) eq 0 then break
         ydat[8*i+j]=dm_to_number(temp1)
       endfor
    endfor
    xdat = xdat[0:nx-1]
    ydat = ydat[0:ny-1]
    for i=0L,nx-1L do begin
       readf,unit,junk   ;read ### S(phi,w)
       for j=0L,(ny+7)/8-1 do begin
         readf,unit,junk
         for k=0,7 do begin
          temp1=strmid(junk,10*k,10)
          if strlen(temp1) eq 0 then break
          zdat[i,8*j+k]=dm_to_number(temp1)
         endfor
       endfor
       readf,unit,junk   ;read ### Errors
       for j=0L,(ny+7)/8-1 do begin
         readf,unit,junk
         for k=0,7 do begin
          temp1=strmid(junk,10*k,10)
          if strlen(temp1) eq 0 then break
          err[i,8*j+k]=dm_to_number(temp1)
         endfor
       endfor
    endfor
    free_lun,unit
end

pro dcs_mslice::dm_load_spe
    file=dm_dialog_input(['spe file:','phx file:'],xsize=150,/browse,filter=['*.spe','*.phx'],dialog_parent=self.tlb)
    widget_control,/HOURGLASS
    openr,unit,file[0],/get_lun,error=error
    if error ne 0 then begin
       ok=dialog_message("Can't read file "+file+'.',dialog_parent=self.tlb)
       return
    endif
    mesg =widget_base(title='Loading data ...',/col,/base_align_center,group_leader=self.tlb)
    label=widget_label(mesg,value='Loading '+file[0]+'. Please wait ...',/dynamic_resize,/align_center)
    dm_center_kid,mesg,self.tlb
    widget_control,mesg,/realize,map=1
    ;catch and clear possible io errors
    catch, myerror
    if myerror ne 0 then begin
       catch,/cancel
       ok=dialog_message(dialog_parent=self.tlb,!error_state.msg,/error)
       if n_elements(unit) ne 0 then free_lun,unit
       return
    end
    ;read the spe file
    dm_load_spe,unit,zdat=qty,err=err,xdat=tth,ydat=en
    qty  = transpose(qty) & err = transpose(err)     ;from [ndet,nen]->[nen,ndet]
    ndet = n_elements(tth)
    dtth = fltarr(ndet)
    psi  = fltarr(ndet)
    dpsi = fltarr(ndet)
    ;read the phx file
    openr,unit,file[1],/get_lun,error=error
    if error eq 0 then begin   ;read phx file
       widget_control,label,set_value='Loading '+file[1]+'. Please wait ...'
       new_ndet=0L
       readf,unit,new_ndet
       if new_ndet eq ndet then begin
         tmp=fltarr(7,ndet)
         readf,unit,tmp
         tth=reform(tmp[2,*])
         psi=reform(tmp[3,*])
         dtth=reform(tmp[4,*])
         dpsi=reform(tmp[5,*])
       endif
       free_lun,unit
    endif
    widget_control,mesg,/destroy
    ;save data and det info in pointers
    ptr_free,self.detPosPtr,self.dataStrPtr
    self.detPosPtr=ptr_new({two_theta:temporary(tth),dtwo_theta:temporary(dtth),psi:temporary(psi),dpsi:temporary(dpsi)})
    self.dataStrPtr=ptr_new({qty:temporary(qty),err:temporary(err),e:temporary(en),ei:!values.f_nan})
    self.is_dcs=0
    self.bgrate=!values.f_nan
    ptr_free,self.bgdata,self.eff,self.mask
    mkcnBut =   widget_info(self.tlb,find_by_uname='mkcnBut')
    mkloBut =   widget_info(self.tlb,find_by_uname='mkloBut')
    mkupBut =   widget_info(self.tlb,find_by_uname='mkupBut')
    dm_toggle_menubut,mkcnBut,[mkcnBut,mkloBut,mkupBut] ;disable mask up,low,bottom function
    self->my_widget_control,'bgclBut',sensitive=0
    self->my_widget_control,'vdclBut',sensitive=0
    self->my_widget_control,'mkclBut',sensitive=0
end