; $Id: dm_proj_view.pro,v 1.5 2003/09/12 19:10:39 qiuym Exp $
; project Q[3,ne,ndet] onto viewing axis U1[4], U2[4], U3[4]
; U1, U2, U3 can only have one with Ui[3] ne 0
function dm_proj_view,Q,en,U1,U2,U3,debug=debug,diffuse=diffuse
	if keyword_set(debug) then begin
		print,'$$proj view...'
		current=systime(/sec)
	endif
	abc		=	[[U1[0:2]],[U2[0:2]],[U3[0:2]]]
	for i=0,2 do begin
		if total(abs(abc[*,i])) eq 0 then begin
			abc[*,i]=crossp(abc[*,(i+1) mod 3],abc[*,(i+2) mod 3])
			break
		endif
	endfor
	V		=	dm_q2hkl(Q,abc,debug=debug)
	if not keyword_set(diffuse) then begin
		tmp		=	size(Q,/dimension)
		E		=	en#(fltarr(tmp[2])+1.0)
		if U1[3] ne 0 then V[0,*,*]=E
		if U2[3] ne 0 then V[1,*,*]=E
		if U3[3] ne 0 then V[2,*,*]=E
	endif
	if keyword_set(debug) then begin
		print,'$$proj view finished in ',systime(/sec)-current,' sec.'
	endif
	return,V
end