; $Id: dm_to_number.pro,v 1.5.2.2 2004/05/28 17:52:01 azuah Exp $
; convert string to numbers,default is to convert to a float
; if the string is empty, return NaN for float or double type
;                return 0 for int,long or byte type
function dm_to_number,numstr,float=float,int=int,double=double,byte=byte,long=long,count=count
    count = n_elements(numstr)
    tmp  = size(numstr,/type)
    if  keyword_set(byte)       then str = numstr $
    else str=dm_to_string(numstr)
    if  keyword_set(int)        then val = intarr(count) $
    else if keyword_set(long)   then val = lonarr(count) $
    else if keyword_set(double) then val = dblarr(count) $
    else if keyword_set(byte)   then val = bytarr(count) $
    else val = fltarr(count)
    on_ioerror,error
    for i=0,count-1 do begin
       flag  =    1
       tmp   = str[i]+' '  ;default, +' ' to force error with emptry string ''
       if keyword_set(int) then val[i]=fix(str[i],type=2) $
       else if keyword_set(long) then val[i]=fix(str[i],type=3) $
       else if keyword_set(byte) then begin
         if i eq 0 then   val = fix(str[i],type=1) $
         else val = [val,fix(str[i],type=1)]
       endif else if keyword_set(double) then val[i]=double(tmp) $
       else val[i]= float(tmp)
       flag  =    0  ;clear error flag
       error: if flag then begin
         if  keyword_set(int)        then val[i] = 0s $
         else if keyword_set(long)   then val[i] = 0l $
         else if keyword_set(double) then val[i] = !values.d_nan $
         else val[i]=!values.f_nan
       endif
    endfor
    return,(count eq 1)?val[0]:val
end