; $Id: davedat__print.pro,v 1.2 2003/01/14 14:58:54 azuah Exp $
;===============================================================================
;
; Richard Tumanjong Azuah
; NCNR, NIST
;
; NAME:_______________________
;   DaveDat::print
;
; PURPOSE:____________________
;   Simple utility method which can be used during development to
;   print a summary of a DaveDat object.
;
; INPUTS:_____________________
;   None.
pro DaveDat::print

print,'______________________________'
print,'### DaveDat object: brief info'
print,''
if (ptr_valid(self.davePtr)) then begin
    print,'********** davePtr is valid **********'
endif else print,'********** davePtr is invalid **********'
print,''
if ptr_valid(self.descriPtr) then begin
    print,'********** descriPtr structure **********'
    help,(*self.descriPtr),/structure
    print,''
endif else begin
    print,'********** descriPtr is invalid **********'
endelse
fstr1 = '(A,T30,A)'
fstr2 = '(A,T30,G10.4)'
fstr3 = '(A,T30,I5)' 
print,format=fstr1,'filename: ',self.filename
print,format=fstr2,'scaleFactor: ',self.scaleFactor
print,''
if ptr_valid(self.xvPtr) then print,format=fstr3,'Xaxis -- length: ',n_elements(*self.xvPtr)
print,format=fstr1,'Xaxis -- label: ',self.xlabel
print,format=fstr1,'Xaxis -- type: ',self.xtype
print,format=fstr1,'Xaxis -- units: ',self.xunits
print,''
if ptr_valid(self.zvPtr) then begin
    zinfo = size(*self.zvPtr)
    print,format=fstr3,'Zaxis -- dimensions: ',zinfo[0]
    print,format=fstr3,'Zaxis -- length (dim 1): ',zinfo[1]
    if (zinfo[0] eq 2) then  print,format=fstr3,'Zaxis -- length (dim 2): ',zinfo[2]
endif
print,format=fstr1,'Zaxis -- label: ',self.zlabel
print,format=fstr1,'Zaxis -- units: ',self.zunits
print,'_________________________________________________________________________'

end
