; $Id: davegr2d__print.pro,v 1.3 2003/04/23 19:41:02 azuah Exp $
;===============================================================================
;
; Richard Tumanjong Azuah
; NCNR, NIST
;
; NAME:_______________________
;   DaveGr2D::print
;
; PURPOSE:____________________
;   Simple utility method which can be used during development to
;   print a summary of a DaveGr object.
;
; INPUTS:_____________________
;   None.

pro DaveGr2D::print

print,'_________________________________________________'
print,'### DaveGr2D object: brief info'
print,''
print,'Plot Type: ',self.plotType
if (ptr_valid(self.dPlotAttribPtr)) then begin
    print,'********** Default Plot Attribute Structure'
    names = tag_names(*self.dPlotAttribPtr)
    for i=0,n_tags(*self.dPlotAttribPtr)-1 do begin
        if (vartype((*self.dPlotAttribPtr).(i)) eq 'POINTER') then begin
            if (ptr_valid((*self.dPlotAttribPtr).(i))) then begin
                print,format='(A20,A2,G10.4)',names[i],' =',*((*self.dPlotAttribPtr).(i))
            endif else begin
                print,format='(A20,A20)',names[i],' =      NULL POINTER'
            endelse
        endif else if (size((*self.dPlotAttribPtr).(i),/tname) eq 'OBJREF') then begin
            print,format='(A20,A2,A20)',names[i],' = ',vartype((*self.dPlotAttribPtr).(i))
        endif else begin
            print,format='(A20,A2,G10.4)',names[i],' =',(*self.dPlotAttribPtr).(i)
        endelse
    endfor 
    print,''
endif
if (ptr_valid(self.plotAttribPtr)) then begin
    print,'********** Plot Attribute Structure'
    names = tag_names(*self.plotAttribPtr)
    for i=0,n_tags(*self.plotAttribPtr)-1 do begin
        if (vartype((*self.plotAttribPtr).(i)) eq 'POINTER') then begin
            if (ptr_valid((*self.plotAttribPtr).(i))) then begin
                print,format='(A20,A2,G10.4)',names[i],' =',*((*self.plotAttribPtr).(i))
            endif else begin
                print,format='(A20,A20)',names[i],' =      NULL POINTER'
            endelse
        endif else if (size((*self.plotAttribPtr).(i),/tname) eq 'OBJREF') then begin
            print,format='(A20,A2,A20)',names[i],' = ',vartype((*self.plotAttribPtr).(i))
        endif else begin
            print,format='(A20,A2,G10.4)',names[i],' =',(*self.plotAttribPtr).(i)
        endelse
    endfor 
    print,''
endif

; display base class component
self->DaveGr::print

end
