; $Id: scale_coord.pro,v 1.1 2003/05/08 20:54:00 azuah Exp $
; Calculate an appropriate scale factor between two vectors
; such that:
;   final_coord[0] = scale0 + scale1*current_coord[0]   and
;   final_coord[1] = scale0 + scale1*current_coord[1]
;
function scale_coord, current_coord, final_coord


res = size(current_coord)
if ((res[0] ne 1) or (res[1] ne 2)) then return,[0.0,1.0]

if (n_elements(final_coord) eq 0) then final_coord=[0.0,1.0]

res = size(final_coord)
if ((res[0] ne 1) or (res[1] ne 2)) then final_coord=[0.0,1.0]

ini = float(current_coord)
fin = float(final_coord)
scale0 = (fin[0]*ini[1] - fin[1]*ini[0]) / (ini[1] - ini[0]) 
scale1 = (fin[1] - fin[0]) / (ini[1] - ini[0])

return, [scale0,scale1]

end
