; $Id: insertvalueinarray.pro,v 1.1 2003/06/13 18:14:46 azuah Exp $
;===============================================================================
;
; Richard Tumanjong Azuah
; NCNR, NIST Feb, 2003
;
; Insert a value into an array at the appropriate location. The array
; becomes expanded and the index at which the value is inserted is
; returned. 
; NB: function only works if the array is sorted in increasing
; numerical order and should only work for numerical arrays.
function insertValueInArray, array, value

res = where(array gt value, count)

case count of
    0: begin                    ; then add new value to end of array
        array = [array,value]
        return, n_elements(array) - 1
    end
    else: begin
        if (res[0] eq 0) then begin ; then add new value to start of array
            array = [value,array]
            return, 0
        endif
        i = res[0]
        array = [array[0:i-1],value,array[i:*]]
        return, i
    end
endcase

end
