; $Id: db_disphist.pro,v 1.1 2003/03/27 14:25:38 azuah Exp $
;===============================================================================
;
; Richard Tumanjong Azuah
; NCNR, NIST
;
; NAME:_______________________
;   db_DispHist
;
; PURPOSE:____________________
;   A small utility widget program to display string array
;   (representing the treatment history for a dataset).
;
; INPUTS:_____________________
;   PARAMETER
;     history:The string array to be displayed.
;
;   KEYWORDS
;     group_leader: the ID of the parent widget from which this dialog
;     was launched.
;
; OUTPUTS:____________________
;     None
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro db_DispHist_event,event

uname = widget_info(event.id,/uname)

case uname of
    'DISMISS': widget_control,event.top,/destroy
    else:
endcase

end


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro db_DispHist, history, group_leader=grpl

; 
title = "DATABROWSER - Data Treatment Log"
if (n_elements(grpl) eq 0) then begin
    modal = 0
    tlb = widget_base(/col,title=title,/base_align_center)
endif else begin
    modal = 1
    tlb = widget_base(group_leader=grpl,modal=modal,/col,title=title,/base_align_center)
endelse

nlines = n_elements(history)
if (nlines le 0) then begin
    nlines = 1
    history = ['No treatment information available!']
endif


xmax = 120
ymax = 60
xsize = 0
ysize = nlines < ymax
for i = 0,nlines-1 do begin
  xsize = xsize > strlen(history[i])
endfor
xsize = xsize < xmax

scroll = 0
if ((xsize ge xmax) or (ysize ge ymax)) then scroll=1
void = widget_text(tlb,value=history,xsize=xsize,ysize=ysize,scroll=scroll,uname='TEXT')

void = widget_button(tlb,value='Dismiss',uname='DISMISS')

widget_control,tlb,/realize

;state = {notifyIds:notifyIds}
;pState = ptr_new(state,/no_copy)
;widget_control,tlb,set_uvalue = pState,/no_copy

xmanager,'db_disphist',tlb,event_handler='db_disphist_event',no_block=modal

return
end
