; $Id: ref_chudley_elliott.pro,v 1.1 2003/05/15 17:18:18 dimeo Exp $
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function ref_chudley_elliott,xvals,parms,						$
                    	parmnames = parmnames,					$
                    	single_parmnames = single_parmnames,	$
                    	multi_parmnames = multi_parmnames,		$
                    	res_ptr = res_ptr,						$
                    	all_y = all_y,							$
                    	_Extra = extra
; all_y keyword is relevant for this model
if n_elements(all_y) eq 0 then all_y = 1
nx = extra.nx & ny = extra.ny
x = xvals[0:nx-1] & y = xvals[nx:nx+ny-1]
ux = 1+bytarr(nx) & uy = 1+bytarr(ny)
parmnames =	['Residence time','Jump distance','Center', $
			'Intensity:'+strtrim(string(indgen(ny)),2)]

single_parmnames = parmnames[0:2]
multi_parmnames = 'Intensity:'
if (n_params() eq 0) or (n_params() eq 1) then begin
  return,-1
endif

tau = parms[0]
l = parms[1]
gam = ux#((0.6528/tau)*(1.0-(sin(y*l))/(y*l)))
center = ux#(parms[2])#uy
intensity = ux#(parms[3:3+ny-1])


lorentzian = ((gam/!dpi))/((x#uy-center)^2+(gam)^2)
lineshape = scat_convolve(x,y,lorentzian,*res_ptr)
yout = intensity*lineshape
return,yout
end