; $Id: pan_macrofunction.pro,v 1.3 2003/09/30 12:20:11 dimeo Exp $
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function pan_macrofunction,x,parms,       $
                     parmnames = parmnames,  $
                     canDraw = canDraw,     $
                     eval = eval,      $
                     _Extra = extra

fit_fun = extra.fit_fun_filename
this_level = routine_names(/level)
main_level = 1
; First determine if the call is for the parameter names only...
if n_params() eq 0 then begin
   str = ''
   openr,lun,fit_fun,/get_lun
   readf,lun,str
   free_lun,lun,/force
   ret = pan_do_the_macro(str[0])
   value  = routine_names('parmnames', fetch = main_level)
   dummy  = routine_names('parmnames', value, store = this_level)
   return,0
endif

; Send the x and parms values to the main level
value  = routine_names('x', fetch = this_level)
dummy  = routine_names('x', value, store = main_level)
value = routine_names('parms',fetch = this_level)
dummy = routine_names('parms',value,store = main_level)

; Read in the macro
counter = 0L
str = ''
openr,lun,fit_fun,/get_lun
while not(eof(lun)) do begin
   readf,lun,str
   if counter eq 0L then macro_text = str else $
     macro_text = [macro_text,str]
   counter = counter+1L
endwhile
free_lun,lun,/force

; If a resolution function is present, retrieve it from the $main$ level
if n_elements(routine_names('resptr',fetch = main_level)) ne 0 then begin
   value  = routine_names('resptr', fetch = main_level)
   dummy  = routine_names('resptr', value, store = this_level)
endif

; Now execute the macro
ret = pan_do_the_macro(macro_text)
eval = 1
if ret eq 0 then begin
   eval = 0
   return,ret
endif
; Retrieve ymodel, ydelta, and parmnames from the main level
if n_elements(routine_names('ymodel', fetch = main_level)) ne 0 then begin
   value  = routine_names('ymodel', fetch = main_level)
   dummy  = routine_names('ymodel', value, store = this_level)
endif
if n_elements(routine_names('delta_params', fetch = main_level)) ne 0 then begin
   value  = routine_names('delta_params', fetch = main_level)
   dummy  = routine_names('delta_params', value, store = this_level)
endif
value  = routine_names('parmnames', fetch = main_level)
dummy  = routine_names('parmnames', value, store = this_level)
canDraw = 0

; If resolution function is present then perform the convolution here
if n_elements(resptr) ne 0 then begin
   if n_elements(ymodel) ne 0 then begin
     yout = rmd_convol(x,resPtr,ymodel,pseudo_delta = delta_params)
   endif else begin
     yout = rmd_convol(x,resPtr,pseudo_delta = delta_params)
   endelse
endif else begin
   yout = 0
   if (n_elements(pseudo_delta) ne 0) and (n_elements(ymodel) eq 0) then begin
     yout = 0
   endif
   if (n_elements(ymodel) ne 0) then begin
     yout = ymodel
   endif
endelse
return,yout
end