; $Id: slab_ss.pro,v 1.3 2004/05/03 14:43:44 john Exp $
;************************************************************************************************
;
; Calculates self-shielding correction factors for slab geometry
; and with thin container.
;
; This program is a user friendly widget program that communicates with a
; program written by John Copley (slab_ss_calc.pro)
;
; Modified out of all recognition starting April 2004 (Inma Peral)
;
;
@slab_ss_Plot
@slab_ss_Procs
@slab_ss_Calc
;
;************************************************************************************************
pro slab_ss_Cleanup,tlb
;************************************************************************************************
;
compile_opt strictarr
;
widget_control,tlb,get_uvalue = pState
;
; Revert to original colors prior to exiting.
tvlct, (*pState).default_colors
;
s = size((*pState).notify_IDs)
if (s[0] eq 1) then count = 0 else count = s[2]-1
;
; Outer If statement added to accomodate standalone operation of "slab_ss" program.
if (size(*(*pState).inPtr,/type) eq 8) then begin
	for j = 0,count do begin
  	slab_ssInfo = {slab_ssEvent,$
                  ID:(*pState).notify_IDs[0,j],$
                  Top:(*pState).notify_IDs[1,j],$
                  Handler:0l,$
                  inPtr:ptr_new(*(*pState).inPtr)}
  	if (widget_info((*pState).notify_IDs[0,j],/valid_id)) then begin $
      widget_control,(*pState).notify_IDs[0,j],send_event = slab_ssInfo
  	endif
	endfor
endif
free_ptr,(*pState).inPtr
;
wdelete,(*pState).winPix
free_ptr,(*pState).phiPtr
free_ptr,(*pState).ssfPtr
free_ptr,pState
;
return
;
end


;************************************************************************************************
pro slab_ss_Quit,event
;************************************************************************************************
;
compile_opt strictarr
;
;
widget_control,event.top,/destroy
;
end

;************************************************************************************************
pro slabHFBSAngles,event
;************************************************************************************************
compile_opt strictarr
;
widget_control,event.top,get_uvalue = pState
widget_control,(*pState).butt_phi,set_value = "HFBS detector angles"
widget_control,(*pState).butt_phi,sensitive=0
widget_control,(*pState).butt_DCS,set_button=0
widget_control,(*pState).butt_user,set_button=0
widget_control,(*pState).butt_HFBS,set_button=1
default_colors=(*pState).default_colors
detangles = dblarr(16)
detangles = [14.46,20.98,27.08,32.31,36.0,43.75,51.5,59.25,67.0,$
             74.75,82.5,90.25,98.0,105.75,113.5,121.5]

ptr_free,(*pState).phiPtr
(*pState).phiPtr = ptr_new(detangles,/no_copy)
slab_ss_calc,(*pState).sigt,(*pState).psio,*(*pState).phiPtr,ssf=ssf,saf=saf
ptr_free,(*pState).ssfPtr
ptr_free,(*pState).safPtr
(*pState).ssfPtr=ptr_new(ssf,/no_copy)
(*pState).safPtr=ptr_new(saf,/no_copy)
wset,(*pState).winPix
;colorset
tvlct,!dave_colors.red,!dave_colors.green,!dave_colors.blue
slab_ss_Plot,event
tvlct,default_colors
wset,(*pState).winVis
device,copy = [0,0,!d.x_size,!d.y_size,0,0,(*pState).winPix]
widget_control,event.top,set_uvalue = pState,/no_copy

return

end

;************************************************************************************************
pro slabDCSAngles,event
;************************************************************************************************
compile_opt strictarr
;
widget_control,event.top,get_uvalue = pState
compile_opt strictarr
;
widget_control,event.top,get_uvalue = pState
widget_control,(*pState).butt_phi,set_value = "DCS detector angles"
widget_control,(*pState).butt_phi,sensitive=0
widget_control,(*pState).butt_HFBS,set_button=0
widget_control,(*pState).butt_DCS,set_button=1
widget_control,(*pState).butt_user,set_button=0
default_colors=(*pState).default_colors
detangles = dblarr(913)


inputfile = !DAVE_AUXILIARY_DIR+"dcs_DetPos2.dat"
ndets = 913
detangles = dblarr(ndets)
index=indgen(ndets)

catch,errno
if (errno ne 0) then begin
  catch,/cancel
  void = dialog_message(/error,["Unknown error detected",!err_string])
  widget_control,event.top,set_uvalue = pState,/no_copy
  return
endif
; display the hourglass symbol to denote we're doing some work here
widget_control,/hourglass
angle = 0.0
num = 0
openr, lun, inputfile, /get_lun
instr = ''
readf,lun,instr
for i = 0,ndets-1 do begin
  readf,lun,num,num,num,num,num,num,num,num,angle
  detangles[i] = angle
endfor
free_lun,lun
index = sort(detangles)
detangles=detangles[index]

ptr_free,(*pState).phiPtr
(*pState).phiPtr = ptr_new(detangles,/no_copy)
slab_ss_calc,(*pState).sigt,(*pState).psio,*(*pState).phiPtr,ssf=ssf,saf=saf
ptr_free,(*pState).ssfPtr
ptr_free,(*pState).safPtr
(*pState).ssfPtr=ptr_new(ssf,/no_copy)
(*pState).safPtr=ptr_new(saf,/no_copy)
wset,(*pState).winPix
;colorset
tvlct,!dave_colors.red,!dave_colors.green,!dave_colors.blue
slab_ss_Plot,event
tvlct,default_colors
wset,(*pState).winVis
device,copy = [0,0,!d.x_size,!d.y_size,0,0,(*pState).winPix]
widget_control,event.top,set_uvalue = pState,/no_copy

return

end

;************************************************************************************************
pro slabuserAngles,event
;************************************************************************************************
compile_opt strictarr
;
widget_control,event.top,get_uvalue = pState
compile_opt strictarr
;
widget_control,event.top,get_uvalue = pState
widget_control,(*pState).butt_phi,sensitive=1
widget_control,(*pState).butt_HFBS,set_button=0
widget_control,(*pState).butt_DCS,set_button=0
widget_control,(*pState).butt_user,set_button=1
default_colors=(*pState).default_colors
phistart = (*pState).phistart_def
phistop  = (*pState).phistop_def
phistep  = (*pState).phistep_def
phivals=[phistart,phistop,phistep]
phivals=strjoin(string(phivals,format='(f7.2)'),',')

widget_control,(*pState).butt_phi,set_value = phivals
nangles = 1+fix((phistop-phistart)/phistep)
phi = phistart+phistep*dindgen(nangles)
ptr_free,(*pState).phiPtr
(*pState).phiPtr = ptr_new(phi,/no_copy)

slab_ss_calc,(*pState).sigt,(*pState).psio,*(*pState).phiPtr,ssf=ssf,saf=saf
ptr_free,(*pState).ssfPtr
ptr_free,(*pState).safPtr
(*pState).ssfPtr=ptr_new(ssf,/no_copy)
(*pState).safPtr=ptr_new(saf,/no_copy)

wset,(*pState).winPix
;colorset
tvlct,!dave_colors.red,!dave_colors.green,!dave_colors.blue
slab_ss_Plot,event
tvlct,default_colors
wset,(*pState).winVis
device,copy = [0,0,!d.x_size,!d.y_size,0,0,(*pState).winPix]
widget_control,event.top,set_uvalue = pState,/no_copy

return

end




;************************************************************************************************
pro slab_ss_Help,event
;************************************************************************************************
;
compile_opt strictarr
;
;res=dialog_message("Sorry. Help is not presently available.")
;return
;pdf_file = !DAVE_AUXILIARY_DIR+'asc.pdf'
pdf_file = file_which('Self_slab_calc.pdf',/include_current_dir)
void = launch_help(pdf_file,tlb = event.top)
return
end



;************************************************************************************************
pro slab_ss_event,event
;************************************************************************************************
;
compile_opt strictarr
;
;
widget_control,event.top,get_uvalue = pState
;
default_colors=(*pState).default_colors

case event.id of
;
	(*pState).butt_save: begin
		;outputfile=!DAVE_AUXILIARY_DIR+'slab_ss.dat'
		outputfile=dialog_pickfile(filter='*.dat')
		if(outputfile eq "") then begin
			res=dialog_message("No file has been selected.")
			return
		endif
			openw,u,outputfile,/get_lun
			names=(*pState).names
			k=0
			printf,u,format='(a10,f12.4)',"thickness ",(*pState).thickness
			printf,u,format='(a10,f12.4)',"sigmat    ",(*pState).sigmat
			printf,u,format='(a10,f12.4)',"sigt      ",(*pState).sigt
			printf,u,format='(a10,f12.4)',"psi0      ",(*pState).psio
			widget_control,(*pState).butt_phi,get_value=phivals
			if (phivals eq 'DCS detector angles') then begin
					printf,u,format='(a20)',"DCS detector angles "
			endif else begin
					if (phivals eq 'HFBS detector angles') then begin
						printf,u,format='(a20)',"HFBS detector angles"
					endif else begin
						printf,u,format='(a20)',"                    "
						phi=*(*pState).phiPtr
						phistart=phi[0]
						nphi=n_elements(phi)
						phistop=phi[nphi-1]
						phistep=(phistop-phistart)/(nphi-1)
   			printf,u,format='(a10,d12.4)',"phistart  ",phistart
   			printf,u,format='(a10,d12.4)',"phistop   ",phistop
   			printf,u,format='(a10,d12.4)',"phistep   ",phistep
					endelse
				endelse
			free_lun,u
	end
;
;
	(*pState).butt_rest: begin
		;inputfile=!DAVE_AUXILIARY_DIR+'slab_ss.dat'
		inputfile=dialog_pickfile(filter='*.dat')
		if(inputfile eq "") then begin
			res=dialog_message("No file has been selected.")
			return
		endif
		widget_control,event.top,get_uvalue = pState
		;if (file_test(inputfile)) then begin
			openr,u,inputfile,/get_lun
			void="thickness "
			;     12345678901234567890
			name="xxxxxxxxxxxxxxxxxxxx"
			k=0
   thickness=1.0
   sigmat=1.0
   sigt=1.0
   psio=0.0d
   phistart=0.0d
   phistep=0.0d
			readf,u,format='(a10,f12.4)',void,thickness
			readf,u,format='(a10,f12.4)',void,sigmat
			readf,u,format='(a10,f12.4)',void,sigt
			readf,u,format='(a10,f12.4)',void,psio
			(*pState).thickness=thickness & 	(*pState).sigmat=sigmat & (*pState).sigt=sigt & (*pState).psio=psio
			readf,u,format='(a20)',name
			case name of
		 "                    ":  begin
				readf,u,format='(a10,d12.4)',void,phistart
				readf,u,format='(a10,d12.4)',void,phistop
				readf,u,format='(a10,d12.4)',void,phistep
				phivals=[phistart,phistop,phistep]
				widget_control,(*pState).butt_thickness,set_value=(*pState).thickness
				widget_control,(*pState).butt_sigmat,set_value=(*pState).sigmat
				widget_control,(*pState).butt_sigt,set_value=(*pState).sigt
				widget_control,(*pState).butt_psio,set_value=(*pState).psio
				widget_control,(*pState).butt_DCS,set_button=0
				widget_control,(*pState).butt_HFBS,set_button=0
				widget_control,(*pState).butt_user,set_button=1
				phivals=strjoin(string(phivals,format='(f7.2)'),',')
				widget_control,(*pState).butt_phi,set_value=phivals
				nangles = 1+fix((phistop-phistart)/phistep)
			 phi = phistart+phistep*dindgen(nangles)
			 ptr_free,(*pState).phiPtr
			 (*pState).phiPtr = ptr_new(phi,/no_copy)
			 slab_ss_calc,(*pState).sigt,(*pState).psio,*(*pState).phiPtr,ssf=ssf,saf=saf
  		ptr_free,(*pState).ssfPtr
				ptr_free,(*pState).safPtr
				(*pState).ssfPtr=ptr_new(ssf,/no_copy)
  		(*pState).safPtr=ptr_new(saf,/no_copy)
				wset,(*pState).winPix
				;colorset
  		tvlct,!dave_colors.red,!dave_colors.green,!dave_colors.blue
  		slab_ss_Plot,event
				tvlct,(*pState).default_colors
				wset,(*pState).winVis
				device,copy = [0,0,!d.x_size,!d.y_size,0,0,(*pState).winPix]
				widget_control,event.top,set_uvalue = pState
				free_lun,u
			end
			'HFBS detector angles': begin
				free_lun,u
				slabHFBSangles,event
			end
			'DCS detector angles ': begin
   	free_lun,u
				slabDCSangles,event
			end
		;endif
	endcase
	end

;
; Handle plot output user preference.
  (*pState).butt_plotssf: begin
  	(*pState).plotwhat=0
  	wset,(*pState).winPix
  	;colorset
  	tvlct,!dave_colors.red,!dave_colors.green,!dave_colors.blue
   slab_ss_2Plotter,event,/redraw
   tvlct,default_colors
   wset,(*pState).winVis
			device,copy = [0,0,!d.x_size,!d.y_size,0,0,(*pState).winPix]
			widget_control,event.top,set_uvalue = pState
  end

;
  (*pState).butt_plotint: begin
   	res=dialog_message("Sorry, is not presently available.")
   	widget_control,(*pState).butt_plotssf,/set_button
   	widget_control,(*pState).butt_plotint,set_button=0
   	event.id=(*pState).butt_plotssf
    return

  end
;
  (*pState).butt_plotord: begin
  		res=dialog_message("Sorry, is not presently available.")
   	widget_control,(*pState).butt_plotssf,/set_button
   	widget_control,(*pState).butt_plotord,set_button=0
   	event.id=(*pState).butt_plotssf
    return
  end
;
	else: begin
  ; the rest phi values, sigmat, thickness and psio
  ; First handle the case where phivals = 'HFBS detector angles'
		widget_control,(*pState).butt_phi,get_value = phivals
  if (phivals eq 'HFBS detector angles') or (phivals eq 'DCS detector angles') then begin
  	widget_control,(*pState).butt_sigmat,get_value = sigmat        & sigmat=float(sigmat)
  	if(n_elements(sigmat) eq 1) then sigmat=sigmat[0]
  	slab_ss_checkinput,event,"sigmat",sigmat,ok,messages
			if (not ok) then begin
				res=dialog_message(messages)
		  widget_control,event.top,set_uvalue = pState
		  return
			endif
			widget_control,(*pState).butt_thickness,get_value = thickness  & thickness=float(thickness)
			if(n_elements(thickness) eq 1) then thickness=thickness[0]
			slab_ss_checkinput,event,"thickness",thickness,ok,messages
			if (not ok) then begin
				res=dialog_message(messages)
		 	widget_control,event.top,set_uvalue = pState
		  return
			endif
			widget_control,(*pState).butt_psio,get_value = psio           &  psio=float(psio)
			if(n_elements(psio) eq 1) then psio=psio[0]
	 	slab_ss_checkinput,event,"psio",psio,ok,messages
			if (not ok) then begin
				res=dialog_message(messages)
		  widget_control,event.top,set_uvalue = pState
		  return
			endif
			sigt=sigmat*thickness
			widget_control,(*pState).butt_sigt,set_value = sigt
			(*pState).sigt=sigmat*thickness
			(*pState).sigmat=sigmat
			(*pState).thickness=thickness
			(*pState).psio=psio
			widget_control,event.top,set_uvalue=pState
			if (phivals eq 'HFBS detector angles') then slabHFBSangles,event
			if (phivals eq 'DCS detector angles')  then slabDCSangles,event
		endif else begin

; Next check the input of phivals

			phivals=strsplit(phivals,',',/extract)
			slab_ss_checkinput,event,"phivals",phivals,ok,messages
			if (not ok) then begin
				res=dialog_message(messages)
		  widget_control,event.top,set_uvalue = pState
		  return
			endif
			philo = phivals[0]
			phihi = phivals[1]
			dphi = phivals[2]
			phivals=strjoin(string(phivals,format='(f7.2)'),',')
  	philo=double(philo)
  	phihi=double(phihi)
  	dphi=double(dphi)

			slab_ss_checkinput,event,"angles",[philo,phihi,dphi],ok,messages
			if (not ok) then begin
				res=dialog_message(messages)
		  widget_control,event.top,set_uvalue = pState
		  return
			endif
;
			nangles = 1+fix((phihi-philo)/dphi)
			phi = philo+dphi*dindgen(nangles)

;then thickness, sigmat, sigt and psio
 		widget_control,(*pState).butt_sigmat,get_value = sigmat
 		widget_control,(*pState).butt_thickness,get_value = thickness
 		widget_control,(*pState).butt_psio,get_value = psio
 		sigmat=float(sigmat)
 		thickness=float(thickness)
 		psio=float(psio)
  	if(n_elements(sigmat)    eq 1)    then sigmat=sigmat[0]
  	if(n_elements(thickness) eq 1)    then thickness=thickness[0]
  	if(n_elements(psio)      eq 1)    then psio=psio[0]
  	slab_ss_checkinput,event,"sigmat",sigmat,ok,messages
			if (not ok) then begin
				res=dialog_message(messages)
		  widget_control,event.top,set_uvalue = pState
		  return
			endif
			slab_ss_checkinput,event,"thickness",thickness,ok,messages
				if (not ok) then begin
					res=dialog_message(messages)
		  	widget_control,event.top,set_uvalue = pState
		  	return
				endif
	 	slab_ss_checkinput,event,"psio",psio,ok,messages
			if (not ok) then begin
				res=dialog_message(messages)
		  widget_control,event.top,set_uvalue = pState
		  return
			endif
  	sigt=sigmat*thickness
  	widget_control,(*pState).butt_sigt,set_value = sigt

  	ptr_free,(*pState).phiPtr
			(*pState).phiPtr = ptr_new(phi,/no_copy)

  	slab_ss_calc,sigt,psio,*(*pState).phiPtr,ssf=ssf,saf=saf

  	ptr_free,(*pState).ssfPtr
			ptr_free,(*pState).safPtr
			(*pState).ssfPtr=ptr_new(ssf,/no_copy)
  	(*pState).safPtr=ptr_new(saf,/no_copy)
  	(*pState).sigmat=sigmat
  	(*pState).sigt=sigt
  	(*pState).thickness=thickness
  	(*pState).psio=psio

  	wset,(*pState).winPix
			;colorset
  	tvlct,!dave_colors.red,!dave_colors.green,!dave_colors.blue
  	slab_ss_Plot,event
			tvlct,default_colors
			wset,(*pState).winVis
			device,copy = [0,0,!d.x_size,!d.y_size,0,0,(*pState).winPix]
			widget_control,event.top,set_uvalue = pState
		endelse
	end


endcase
;
widget_control,event.top,set_uvalue = pState
;
end


;************************************************************************************************
pro slab_ss,$
      	inPtr=inPtr,$
      	group_leader = group_leader,$
      	notify_ids = notify_ids,  $
       register_name = register_name
;************************************************************************************************
;
compile_opt strictarr
;
; Slab sample with thin container
;
; Following 3 statements added to accomodate standalone operation of "slab_ss" program.
if (n_elements(notify_IDs) eq 0) then notify_IDs=[0l,0l]
if (not ptr_valid(inPtr)) then inPtr=ptr_new(1)
if (n_elements(group_leader) eq 0) then group_leader=0l
if (n_elements(register_name) eq 0) then register_name = 'slab_ss'
;
; Only allow one instance to be running.
if (xregistered(register_name)) then begin
	res=dialog_message("Only one instance of this program may be running.",/information)
	return
endif
;
davesysvars
; loadct,0,/silent
; Use Alan's routine to load some colors.
default_colors=bindgen(256,3)
tvlct,default_colors,/get       ; get current color settings
;
; Initial (default) values of thickness and  cross sections.
thickness_def=0.1
sigmat_def=1.0
psio_def=60.0
thickness=thickness_def
sigmat=sigmat_def
psio=psio_def
sigt=sigmat*thickness

; Default scattering angles.
phistart_def=double(-180.0)
phistop_def=double(180.0)
phistep_def=double(2.0)
phistart=phistart_def
phistop=phistop_def
phistep=phistep_def
;
; Detector angles.
nangles=1+fix((phistop-phistart)/phistep)
phi=phistart + phistep*dindgen(nangles)
dimension=n_elements(phi)
ssf=fltarr(dimension)
saf=fltarr(dimension)

;
; By default self shielding factors are plotted.
plotwhat=0
; Maximun number of plots
max_n_plots=10

; Define "names" to be used when the conditions are saved
names=['thickness','sigmat','sigt','psio','phistart','phistop','phistep']

; Screen size, used to size the widget.
xysize=get_screen_size()
;
; Create the widget.
tlb = widget_base(/row,title = $
      'Self-Shielding Calculator for Slab Geometry: thin container',$
      mbar = bar,tlb_frame_attr = 1,group_leader = group_leader)
	filemenu = WIDGET_BUTTON(bar, VALUE='File', /MENU)
		void = widget_button(filemenu,value = 'Write results to an ascii file',$
       event_pro = 'slab_ss_WriteFactors',xsize = buttonSize)
	 void = widget_button(filemenu,value = 'Print results to a PS file',$
         event_pro = 'slab_ss_2Printer',xsize = buttonSize,sensitive = 1)
  butt_save = widget_button(filemenu,value='Save input parameters')
   	butt_rest = widget_button(filemenu,value='Restore input parameters')
		void = widget_button(filemenu,value = 'Help',$
       event_pro = 'slab_ss_Help')
		void = widget_button(filemenu,value = 'Quit',$
       event_pro = 'slab_ss_Quit')
;
optionsmenu =widget_button(bar,value='Options',/menu)
butt_HFBS = widget_button(optionsmenu,value = 'HFBS Detector Angles',$
       event_pro = 'slabHFBSAngles',/checked_menu,xsize = buttonSize,sensitive=1)
butt_DCS  = widget_button(optionsmenu,value = 'DCS Detector Angles',$
       event_pro = 'slabDCSAngles',/checked_menu,xsize = buttonSize,$
       sensitive = 1)
butt_user  = widget_button(optionsmenu,value = 'Start, stop and step in 2theta (deg)',$
       event_pro = 'slabuserangles',/checked_menu,xsize = buttonSize,$
       sensitive = 1)
widget_control,butt_HFBS,set_button=0
widget_control,butt_DCS,set_button=0
widget_control,butt_user,/set_button

	butbase=widget_base(tlb,/col);,xsize = xs)
		samplebase=widget_base(butbase,/col,/frame);,xsize = xs1)
			void=widget_label(samplebase,value = 'Sample dimension, geometry and cross sections',frame = 0,/align_center)
  samplebase1=widget_base(samplebase,/row)
  samplebase2=widget_base(samplebase,/row)
		 butt_thickness=cw_field(samplebase1,/col,title='Slab thickness (cm)',font='TIMESROMAN*14',$
              xsize=6,ysize=1,/string,/all_events,uname=slabthickness,value=string(thickness,format='(f7.3)'))
   butt_sigmat   =cw_field(samplebase1,/col,title='Sigma_t (cm-1)            ',font='TIMESROMAN*14',$
              xsize=6,ysize=1,/string,/all_events,uname=sigmat,value=string(sigmat,format='(f7.3)'))
   butt_sigt=cw_field(samplebase1,/col,title='Sigma_t*thickness     ',font='TIMESROMAN*14',$
              xsize=6,ysize=1,/string,/all_events,uname=sigt,value=string(sigt,format='(f7.3)'),/noedit)
   butt_psio=cw_field(samplebase2,/col,title='Psi_0 angle (deg)        ',font='TIMESROMAN*14',$
              xsize=6,ysize=1,/string,/all_events,uname=psio,value=string(psio,format='(f7.3)'))


		anglebase = widget_base(butbase,/col,/frame);,xsize = xs1)
			void = widget_label(anglebase,value = 'Start, stop and step in 2theta (deg)',$
				frame = 0,/align_center)
			phivals=[phistart,phistop,phistep]
			phivals=strjoin(string(phivals,format='(f7.2)'),',')
			;butt_phi=cw_field(anglebase,value=phivals,/editable,/array,/allevents)
			butt_phi = widget_text(anglebase,value=phivals,/all_events,/editable)

;		outbase = widget_base(butbase,/row)
;				outbase2 = widget_base(outbase,/frame,/col,/exclusive)
				butt_plotssf = 0
;  			butt_plotssf = widget_button(outbase2,$
;   				value='Show self-shielding factors',/no_release)
   				butt_plotint = 0
; 				butt_plotint = widget_button(outbase2,$
;   				value='Show scattering intensities',/no_release)
					butt_plotord = 0
; 				butt_plotord = widget_button(outbase2,$
;   				value='Show summed scattering intensity',/no_release)
;		  	widget_control,butt_plotssf,/set_button

 winlegxsize=xysize[0]*0.5
 winlegysize=xysize[0]*0.25

;
	plotbase = widget_base(tlb,/col)
		buttonSize = 100
;
		butgeom=widget_info(butbase,/geometry)
;
		winxsize = xysize[0]*0.75-butgeom.xsize; -midgeom.xsize
		winysize = xysize[1]*0.5
;
		win = widget_draw(plotbase,xsize = winxsize,ysize = winysize,$
      /button_events,/motion_events,event_pro='slab_ss_WinDraw')
		butbase2 = widget_base(plotbase,/row)
			transbase = widget_base(butbase2,/align_left,/col)
				meantrans = widget_label(transbase,value=' ',xsize=winxsize*0.25)
				mintrans = widget_label(transbase,value=' ',xsize=winxsize*0.25)
			message_area = widget_label(butbase2,value=' ',xsize=winxsize*0.75)

;
centertlb,tlb
widget_control,tlb,/realize
;
; Create a pixmap. Get IDs of pixmap and plot window.
!p.charsize = 1.0
window,/free,/pixmap,xsize = winxsize,ysize = winysize
winPix = !d.window
widget_control,win,get_value = winVis
;
; Get ssf and saf to be plotted after defining state
slab_ss_calc,sigt,psio,phi,ssf=ssf,saf=saf

state = {$
		winxsize:winxsize,$
		winysize:winysize,$
;
; Widget IDs
  butt_thickness:butt_thickness,$
  butt_sigmat:butt_sigmat,$
  butt_sigt:butt_sigt,$
  butt_psio:butt_psio,$
		butt_phi:butt_phi,$
		butt_plotssf:butt_plotssf,$
		butt_plotint:butt_plotint,$
		butt_plotord:butt_plotord,$
		butt_save:butt_save,$
		butt_rest:butt_rest,$
		butt_DCS:butt_DCS,$
		butt_HFBS:butt_HFBS,$
		butt_user:butt_user,$
		meantrans:meantrans,$
		mintrans:mintrans,$
		message:'',$
		message_area:message_area,$
		names:names,$
		thickness:thickness,$
		sigmat:sigmat,$
		sigt:sigt,$
  psio:psio,$
		plotwhat:0,$
		beam_ydispl:0.1,$
		beam_wid:0.1,$
		phistart_def:phistart_def,$
		phistop_def:phistop_def,$
		phistep_def:phistep_def,$
		thickness_def:thickness_def,$
		sigmat_def:sigmat_def,$
		psio_def:psio_def,$

;
; Other stuff.
		winVis:winVis,$
		winPix:winPix,$
		xlo:0.0,$
		ylo:0.0,$
		xhi:1.0,$
		yhi:1.0,$
		mouse:0,$
		xp1:0.0,$
		xp2:0.0,$
		yp1:0.0,$
		yp2:0.0,$
		autoscale:1,$
		max_n_plots:max_n_plots,$
		default_colors:default_colors,$
		plotting_geometry:0,$
		phiPtr:ptr_new(phi),$
		safPtr:ptr_new(saf),$
		ssfPtr:ptr_new(ssf),$
		n_plots:0,$
		inPtr:inPtr,$
    bangx:!x,$
    bangy:!y,$
    bangp:!p,$
		notify_IDs:notify_IDs}
;
widget_control,tlb,set_uvalue = ptr_new(state)
widget_control,tlb,get_uvalue=pState

pseudoEvent = {event,id:void,top:tlb,handler:0l}
wset,(*pState).winPix
colorset
tvlct,!dave_colors.red,!dave_colors.green,!dave_colors.blue
slab_ss_Plot,pseudoevent
tvlct,default_colors
wset,(*pState).winVis
device,copy = [0,0,!d.x_size,!d.y_size,0,0,(*pState).winPix]
widget_control,tlb,set_uvalue=pState

;
xmanager,register_name,tlb,/no_block,cleanup = 'slab_ss_Cleanup',$
	event_handler="slab_ss_event"
;
return
end


