; $Id: slab_ss_Plot.pro,v 1.2 2004/05/03 14:45:00 john Exp $
;************************************************************************************************
;
; These procedures are used by the program "slab_ss"
;

;************************************************************************************************
pro slab_ss_2Plotter,event,redraw=redraw
;************************************************************************************************
;
compile_opt strictarr
;
widget_control,event.top,get_uvalue = pState
if (n_elements(*(*pState).ssfPtr) eq 0) then begin
	res=dialog_message("There is nothing to plot.",/information)
	return
endif
;
wset,(*pState).winPix
if (keyword_set(redraw)) then redraw=1 else redraw=0
slab_ss_Plot,event,redraw=redraw
wset,(*pState).winVis
device,copy = [0,0,(*pState).winxsize,(*pState).winysize,0,0,(*pState).winPix]
widget_control,event.top,set_uvalue = pState
end


;************************************************************************************************
pro slab_ss_2Printer,event
;************************************************************************************************
;
compile_opt strictarr
;
widget_control,event.top,get_uvalue = pState
if (n_elements(*(*pState).ssfPtr) eq 0) then begin
	res=dialog_message("There is no plot to be printed.",/information)
	return
endif
;
thisDevice = !d.name
device_keywords = PSConfig(Cancel=canceled,group_leader = event.top,$
    DefaultSetup="Centered (Landscape)")
if canceled ne 1 then begin
  SET_PLOT, 'PS'
  DEVICE, _Extra = device_keywords
  slab_ss_Plot,event,/redraw
  DEVICE, /CLOSE_FILE
  set_plot,thisDevice
endif
return
end


;************************************************************************************************
pro slab_ss_Plot,event,redraw=redraw
;************************************************************************************************
;
compile_opt strictarr
;
widget_control,event.top,get_uvalue = pState
;
;
if (n_elements(*(*pState).ssfPtr) eq 0) then begin
	res=dialog_message("Nothing found to plot in SLAB_SS_PLOT",/information)
	return
endif

;
symsize=1.333

;
;	Define the abscissa.
	absciss = *(*pState).phiPtr
	nabsc=n_elements(absciss)
;
; Define ordinates.

plotwhat=(*pState).plotwhat
case plotwhat of
	0: begin
		ordinate =[[*(*pState).ssfPtr],[*(*pState).safPtr]]
		help,ordinate
	end
	1: begin
		res=dialog_message("Sorry, this feature is not yet available.")
	end
	2: begin
		res=dialog_message("Sorry, this feature is not yet available.")
		return
	end
endcase
;

	if ((*pState).autoscale eq 1) then begin
	  (*pState).xlo = min(absciss)
	  (*pState).xhi = max(absciss)
	  (*pState).ylo = 0.0
	  (*pState).yhi = 1.2*max(ordinate)
	endif
;

		!x=(*pState).bangx
		!y=(*pState).bangy
		!p=(*pState).bangp
		plot,absciss,ordinate[*,0],$
			xstyle=1,xrange=[(*pState).xlo,(*pState).xhi],$
			ystyle=1,yrange=[(*pState).ylo,(*pState).yhi],$
		 xtitle='!32!4h!3 (degrees)',$
    psym=-dave_selsym(5),symsize=symsize,$
		 color=1,background=0
		oplot,absciss,ordinate[*,1],$
		  psym=-dave_selsym(5),symsize=symsize,$
		 color=2
		 psym1= -dave_selsym(5)
		legend,help=help,["SSF","SAF"],linestyle=linestyle,psym=[psym1,psym1],$
		       box=0,color=[1,2],textcolors=[1,2],charsize=1,position=[0.65,0.95]
		(*pState).bangx=!x
		(*pState).bangy=!y
		(*pState).bangp=!p

;
widget_control,event.top,set_uvalue = pState
;
return
end