; $Id: slab_ss_Procs.pro,v 1.2 2004/05/03 14:42:09 john Exp $
;************************************************************************************************
;
; These procedures are used by the program "slab_ss"
;
;************************************************************************************************
pro slab_ss_checkinput,event,checkstring,vals,ok,messages
;************************************************************************************************
;
compile_opt strictarr
widget_control,event.top,get_uvalue = pState
;
;
ok=1
;
messages=''
case checkstring of
	"phivals": begin
		if(event.id eq (*pState).butt_phi) then begin
		if(n_elements(vals) ne 3) then begin
			ok=0
			messages=[messages,'You must provide three numbers!']
   ;return to the default values
		phistart = (*pState).phistart_def
		phistop  = (*pState).phistop_def
		phistep  = (*pState).phistep_def
   phivals=[phistart,phistop,phistep]
			phivals=strjoin(string(phivals,format='(f7.2)'),',')
			widget_control,(*pState).butt_phi,set_value = phivals
			slab_ss_event,event
		endif
		endif
	end
	"angles": begin
		if(event.id eq (*pState).butt_phi) then begin
			philo=vals[0]
			phihi=vals[1]
			dphi=vals[2]
			if (philo ge phihi) then begin
				ok=0
				messages=[messages,'Start angle must be less than stop angle!']
   	;return to the default values
		phistart = (*pState).phistart_def
		phistop  = (*pState).phistop_def
		phistep  = (*pState).phistep_def
   	phivals=[phistart,phistop,phistep]
				phivals=strjoin(string(phivals,format='(f7.2)'),',')
				widget_control,(*pState).butt_phi,set_value = phivals
				slab_ss_event,event
			endif
			if (dphi le 0.d0) then begin
				ok=0
				messages=[messages,'Step in angle must be positive!']
				;return to the default values
		phistart = (*pState).phistart_def
		phistop  = (*pState).phistop_def
		phistep  = (*pState).phistep_def
   	phivals=[phistart,phistop,phistep]
				phivals=strjoin(string(phivals,format='(f7.2)'),',')
				widget_control,(*pState).butt_phi,set_value = phivals
				slab_ss_event,event
			endif
		endif
	end
;
	"sigmat": begin
			if(event.id eq (*pState).butt_sigmat) then begin
	 	if(vals lt 0.d) then begin
	 		ok=0
    messages=[messages,'Sigmat cannot be negative!']
    ;return to the default values
   	sigmat=(*pState).sigmat_def
   	widget_control,(*pState).butt_sigmat,set_value = sigmat
   	slab_ss_event,event
  	endif
  	endif
  end

;
	"thickness": begin
	 if(event.id eq (*pState).butt_thickness) then begin
		if (vals lt 0.d) then begin
		 ok=0
  	messages=[messages,'Thickness cannot be negative!']
   thickness=(*pState).thickness_def
   widget_control,(*pState).butt_thickness,set_value = thickness
   slab_ss_event,event
  endif
  endif
	end
;
	"psio": begin
		if (event.id eq (*pState).butt_psio) then begin
	 if (vals lt -90.0) or (vals gt 90.0) then begin
			ok=0
	 	messages=[messages,'Psi0 must be between -90.0 and 90.0; for details visit Help']
   psio=(*pState).psio_def
   widget_control,(*pState).butt_psio,set_value = psio
	  slab_ss_event,event
		endif
		endif

	end

;
	else:
endcase
;
end







;************************************************************************************************
pro slab_ss_WinDraw,event
;************************************************************************************************
;
compile_opt strictarr
;
widget_control,event.top,get_uvalue = pState
if (not (*pState).plotting_geometry and n_elements(*(*pState).ssfPtr) eq 0) then return
;
default_colors=(*pState).default_colors
;colorset
tvlct,!dave_colors.red,!dave_colors.green,!dave_colors.blue

!x=(*pState).bangx
!y=(*pState).bangy
!p=(*pState).bangp

;
case event.type of
0: begin  ; button press
	(*pState).mouse = event.press
	if (*pState).mouse eq 4 then begin
	  (*pState).autoscale = 1
			;colorset
  	tvlct,!dave_colors.red,!dave_colors.green,!dave_colors.blue
  	wset,(*pState).winPix
			slab_ss_2plotter,event,/redraw
			wset,(*pState).winVis
			device,copy = [0,0,!d.x_size,!d.y_size,0,0,(*pState).winPix]
			tvlct,default_colors
   (*pState).mouse = 0
   widget_control,event.top,set_uvalue = pState
   tvlct,default_colors
	  return
	endif
	(*pState).xp1 = event.x
	(*pState).yp1 = event.y
	(*pState).autoscale = 0
   end
;
1: begin	; button release
	if ((*pState).mouse eq 1) then begin
		x = (*pState).xp1 < (*pState).xp2
		y = (*pState).yp1 < (*pState).yp2
		w = abs((*pState).xp1 - (*pState).xp2)
		h = abs((*pState).yp1 - (*pState).yp2)
		x2 = x+w
		y2 = y+h
		lc = convert_coord(x, y, /device, /to_data)
		uc = convert_coord(x2, y2, /device, /to_data)
		(*pState).xlo = lc[0] & (*pState).xhi = uc[0]
		(*pState).ylo = lc[1] & (*pState).yhi = uc[1]
		;colorset
  tvlct,!dave_colors.red,!dave_colors.green,!dave_colors.blue
  wset,(*pState).winPix
		slab_ss_2plotter,event,/redraw
		wset,(*pState).winVis
		device,copy = [0,0,!d.x_size,!d.y_size,0,0,(*pState).winPix]
		tvlct,default_colors
	endif
	(*pState).mouse = 0
   end
;
2: begin	; mouse motion
    if ((*pState).mouse eq 1) then begin
    	(*pState).xp2 = event.x
    	(*pState).yp2 = event.y
    	xc = [(*pState).xp1, event.x, event.x, (*pState).xp1, (*pState).xp1]
    	yc = [(*pState).yp1, (*pState).yp1, event.y, event.y, (*pState).yp1]
					wset, (*pState).winVis
	    device, copy = [0,0,(*pState).winxsize,(*pState).winysize,0,0, (*pState).winPix]
	    ;colorset
  			tvlct,!dave_colors.red,!dave_colors.green,!dave_colors.blue
    	plots, xc, yc, /device, color=1
    	tvlct,default_colors
    endif
   end
else:
endcase
widget_control,event.top,set_uvalue = pState
tvlct,default_colors
return
end


;************************************************************************************************
pro slab_ss_WriteFactors,event
;************************************************************************************************
;
compile_opt strictarr
;
widget_control,event.top,get_uvalue = pState
;
if (n_elements(*(*pState).ssfPtr) eq 0) then begin
	res=dialog_message("Nothing found to save to a file.",/information)
	return
endif
;
;cd,(*!dave_defaults).workDir
filename=dialog_pickfile(dialog_parent=event.top,filter='*.txt',/write,title='Output file')
if (strlowcase(strmid(filename,strlen(filename)-4)) ne '.txt') then filename=filename+'.txt'
openw,lun,filename,/get_lun
;
phi=*(*pState).phiPtr
phistart=phi[0]
nphi=n_elements(phi)
phistop=phi[nphi-1]
phistep=(phistop-phistart)/(nphi-1)
phivals=[phistart,phistop,phistep]
			phivals=strjoin(string(phivals,format='(f7.2)'),',')

printf,lun,"thickness (cm)"
printf,lun,(*pState).thickness
printf,lun,"sigmat (cm-1)"
printf,lun,(*pState).sigmat
printf,lun,"sigt"
printf,lun,(*pState).sigt
printf,lun,"psio (deg)"
printf,lun,(*pState).psio
printf,lun,"philo,phihi,phistep (deg)"
printf,lun,phivals
;
;

	;
	for i=0,nphi-1 do begin
	  dataOut=(*(*pState).phiPtr)[i]
	  if ((*pState).plotwhat eq 0) then begin
	  		if (i eq 0) then 	printf,lun,"Angle, SSF and SAF"
	    dataOut=[dataOut,(*(*pState).ssfPtr)[i],(*(*pState).safPtr)[i]]
			endif else begin
				res=dialog_message('Sorry, not yet available')
			endelse
  	printf,lun,dataOut,format=thisFormat
endfor
;
free_lun,lun
;
return
end


;************************************************************************************************
pro slab_ss_procs
;************************************************************************************************
;
compile_opt strictarr
;
end