; $Id: define_vmPDFReader.pro,v 1.1 2004/03/24 18:49:23 john Exp $
;************************************************************************************************
function define_vmPDFReader,tlb=tlb
;************************************************************************************************
;
compile_opt strictarr
;
;
PDFReader=''
file=sourceroot()+"pdfreader.txt"
if (file_test(file)) then begin
	openr,unit,file,/get_lun
	readf,unit,PDFReader
	free_lun,unit
endif
;
if (PDFReader ne '' and PDFReader ne ' ') then begin
	message=["Your pdf reader is already defined as follows:",'',PDFReader,'',$
			"Do you wish to redefine your pdf reader?"]
	if (n_elements(tlb) gt 0) then begin
		res=dialog_message(message,/question,/default_no,dialog_parent=tlb)
	endif else begin
		res=dialog_message(message,/error,/default_no)
	endelse
	if (res eq "Yes") then PDFReader='' else return,2
endif
;
;
; UNIX platforms only - if the PDF reader is not specified attempt to locate one.
if (strlowcase(!version.os_family) eq "unix") then begin
	readers = ['acroread','kghostview','xpdf']   ; programs to search for
	ind = 0
	while ((PDFReader eq '' or PDFReader eq ' ') and ind lt 3) do begin
		cmd = 'which '+readers[ind]
		spawn, cmd,result   ; problems in IDL5.4 if attempt to assign PDFReader to 'spawn'
		PDFReader=result[0] ; result directly - result is an array after first attempt.
		ind = ind + 1
	endwhile
endif
;
; All platforms - if the PDF reader is not specified launch a dialog that asks to set it.
if (PDFReader eq '' or PDFReader eq ' ') then begin
	ptext="Please specify your PDF reader"
	path="C:\Program Files\Adobe"
	if (n_elements(tlb) gt 0) then begin
		PDFReader = dialog_pickfile(dialog_parent=tlb,/read,title=ptext,path=path)
	endif else begin
		PDFReader = dialog_pickfile(/read,title=ptext,path=path)
	endelse
endif
;
; If the pdfReader was picked then save it.
if (PDFReader ne '' and PDFReader ne ' ') then begin
	file=sourceroot()+"pdfreader.txt"
	openw,unit,file,/get_lun
	printf,unit,PDFReader
	free_lun,unit
endif else begin
	return,-1
endelse
;
end


