;$Id: rasdfiles.pro,v 1.4 2004/02/20 16:15:15 azuah Exp $
function readword,ttemp,num

;to read the Nth word from a string. The words are seperated by "'" and ' '

;temp:the string
;num:the number of the  word in the string

temp=''

temp=' '+ttemp
l=strlen(temp)
n=0
flag=0
comp=' '    ;use ' ' as the seperation of words
length=0    ;length of the word
initial=0   ;starting position of the word

for i=0,l-1 do BEGIN
	IF (FLAG) THEN BEGIN

		;to tell a word like:"    'word'"

		IF (comp EQ ' ' AND strmid(temp,i,1) EQ "'" AND length EQ 0) $
		THEN BEGIN
			comp="'"
			initial=i
		ENDIF

		;find the end of a word
		IF (strmid(temp,i,1) EQ comp ) THEN BEGIN

			;is the ' ' or "'" before or after the word?

			IF (length NE 0) THEN BEGIN
				IF (n EQ num) THEN goto,sendword ELSE BEGIN
					n=n+1
					comp=' '
					initial=i+1
					length=0
				ENDELSE
			ENDIF ELSE initial=initial + 1
		ENDIF ELSE length=length +1
	ENDIF ELSE BEGIN
		IF (strmid(temp,i,1) EQ ' ') THEN BEGIN
			comp=' '
			FLAG=1
			initial=i+1
		ENDIF
		IF (strmid(temp,i,1) EQ "'") THEN BEGIN
			comp="'"
			FLAG=1
			initial=i+1
		ENDIF
	ENDELSE
endfor

if n ne num then length=0

sendword:str=strmid(temp,initial,length)
return,str
end



pro weedoub,xin,fxin,dfxin,dx,xn,fxn,dfxn,srt=srt
;****************************************************************
;*								*
;* input array of measurements of a function of one variable 	*
;* with error bars. returns a sorted version of array with   	*
;* all points measured within dx of one another averaged	*
;* statistically correctly					*
;*								*
;* Input :							*
;*	x	:	Array of unsorted values of free	*
;*			variable				*
;*	fx	:	measured values of function at those	*
;*			points					*
;*	dfx	:	error bars on those measurements	*
;*	dx	:	tolerance in x beyond which fx are	*
;*			considered different			*
;*	srt	:	if present assume x is sorted on input	*
;*	gauss	:	by default poisson statistics is used :	*
;*								*
;*				average=sum/N			*
;*				error=sqrt(sum(error^2))/N	*
;*								*
;*			if keyword normd is present and not 0	*
;*			gaussian distribution is assumed :	*
;*								*
;*				average=sum(y/dy^2)/sum(1/dy^2)	*
;*				error=1/sqrt(sum(1/dy^2))	*
;*								*
;* Output :							*
;*	xn	:	sorted values of free variable		*
;*	fxn	:	corresponding best estimates of		*
;*			function				*
;*	dfxn	:	error bars on fxn			*
;*								*
;****************************************************************
nx	=	n_elements(xin)

;--------------------------------------------------
;| copy input to other array so as not to destroy |
;--------------------------------------------------
x	=	fltarr(nx)
fx	=	fltarr(nx)
dfx	=	fltarr(nx)
x	=	xin
fx	=	fxin
dfx	=	dfxin

xn	=	fltarr(nx)
fxn	=	fltarr(nx)
dfxn	=	fltarr(nx)


if not keyword_set(srt) then ix=sort(x) else ix=findgen(nx)

;----------------------
;| Poisson Statistics |
;----------------------
in	=	-1
j	=	-1
for i=0,nx-1 do begin				$
 if i gt j then begin				$
  fxav	=	0
  ins2	=	0
  xtot	=	0
  nav	=	0
  for j=i,nx-1 do begin				$
   if abs(x(ix(i))-x(ix(j))) gt dx then goto,different
    xtot	=	xtot+x(ix(j))
    fxav	=	fxav+fx(ix(j))
    ins2	=	ins2+dfx(ix(j))^2
    nav		=	nav+1
  endfor
  different:
  j=j-1
  in	=	in+1
  xn(in)	=	xtot/nav
  fxn(in)	=	fxav/nav
  dfxn(in)	=	sqrt(ins2)/nav
 endif
endfor


xn	=	xn(0:in)
fxn	=	fxn(0:in)
dfxn	=	dfxn(0:in)

end

pro avy,x,y,z,dz,dx,xo,zo,dzo,yran=yran

if n_elements(yran) ne 2 then yran=[min(y),max(y)]
n	=	n_elements(x)

lis	=	where( (y ge yran(0) and y le yran(1)) and z gt -1e30,no)
if no eq 0 then print,'from avy.pro, no data points'
xo	=	x(lis)
zo	=	z(lis)
dzo	=	dz(lis)

weedoub,xo,zo,dzo,dx,xo,zo,dzo

end



function flunct,arry
;________________________________________________________________
;|								|
;| function to calculate the delta value, which is sqrt of 	|
;| ( square's average - average's square)/average's square	|
;|______________________________________________________________|
n	=	n_elements(arry)
ave	=	total(arry)/n
if abs(ave) lt 1.e-3 then return,0
aves	=	total(arry^2)/n
return,sqrt(abs(aves-ave^2)/ave^2)
end

pro sxyar,d,in
;________________________________________________________________
;|								|
;| Selecting the x and y axis from the data structure.		|
;| subroutine of the sxya.pro					|
;| 								|
;| input :							|
;|	-- data,  data array in the structure,assumining that	|
;|	          data(*,1) & data(*,2) are the			|
;|		  intensity and corresponding error bars	|
;| output:							|
;|	-- in, 	  the index 		 			|
;|		  data(*,in) has the maximum deviation		|
;|		  if the deviation of data(*,0) is zero		|
;|______________________________________________________________|

nde		=	n_elements(d[0,*])
delt		=	fltarr(nde)
for i=0,nde-1 do delt(i)	=	flunct(d[*,i])

delt(1)	=	-1.e32
delt(2)	=	-1.e32
lis	=	sort(delt)
in	=	lis(nde-1)

end


pro sxya,datas
;________________________________________________________________
;|								|
;| Selecting the x and y axis from the data structure.		|
;| subroutine of the rnistq.pro					|
;| Differing from saxis.pro this routine is to select the 	|
;| horizontal variable with reference to the standard deviation	|
;| If the standard deviation of datas.de(*,0) is no zero, 	|
;| nothing will be changed					|
;| 								|
;| Input :							|
;|	- datas, the data structure.				|
;|								|
;| Output :							|
;|	- datas, with right x axis				|
;|______________________________________________________________|

dedd				=	fltarr(datas.ndp,datas.nde)
dedd				=	datas.de(*,*)
	sxyar,dedd,inn
	tde0			=	datas.tde(0)
	ude0			=	datas.ude(0)
	datas.de(*,0)		=	dedd(*,inn)
	datas.de(*,inn)		=	dedd(*,0)
	datas.tde(0)		=	datas.tde(inn)
	datas.ude(0)		=	datas.ude(inn)
	datas.tde(inn)		=	tde0
	datas.ude(inn)		=	ude0

end

pro roneasdq,file_name,d,gaussan=gaussan,xtitle=xtt,ytitle=ytt
;--------------------------------------------------------------------
;|								    |
;| Purpose	: Read ASD data file of the format which is produced|
;|		  by the NIST neutron spectrometer controle program |
;|		  ICP  const-Q buffer				    |
;|								    |
;|								    |
;| Input	: file-name, the file to be read		    |
;| Output	: data, the data structure			    |
;| externals	: gendast, to generate data structure		    |
;|								    |
;--------------------------------------------------------------------

in	=	1000
junk		=	''
efixt		=	''
fnam		=	''
date		=	''
scanty		=	''
dataty		=	''
tit		=	''
dede		=	fltarr(in,9)
dqc		=	fltarr(3)
ddq		=	dqc


openr,lun,file_name,/get_lun

;----------------------------------
;| read in header data for q-file |
;----------------------------------
readf,lun,format='(x,a12,3x,a17,3x,a1,5x,f8.0,f7.0,1x,a4,2x,i4,3x,a3,2x)',$
      fnam,date,scanty,r0,r1,scanty,npt,dataty
mon	=	r0*r1

readf,lun,junk
readf,lun,format='(a100)',tit
readf,lun,format='(4i3,5x,3i3,7x,9x,f8.3)', $
      col0,col1,col2,col3,msm,mss,msa,dangle
readf,lun,junk
readf,lun,aa,bb,cc,alfa,beta,gama
readf,lun,junk
readf,lun,dec,dde,def,dmdsp,dadsp,dtmpst,tinc
readf,lun,format='(27x,a8)',efixt
readf,lun,dqc,ddq,dhfld
readf,lun,junk
readf,lun,format='(x,a12,8x,i4)',junk,npix
readf,lun,junk

; asd data format
tempasd	=	fltarr(npix)
asd	=	fltarr(in,npix)

;Count the number of columns to be read. Assume standard set of columns.
iw	=	0
while ( readword(junk,iw) ne '') do iw	=	iw+1

dqc0	=	dqc(0)		&	ddq0	=	ddq(0)
dqc1	=	dqc(1)		&	ddq1	=	ddq(1)
dqc2	=	dqc(2)		&	ddq2	=	ddq(2)

taum	=	2.*!pi/dmdsp
taua	=	2.*!pi/dadsp

;-----------------------------
;| start reading actual data |
;-----------------------------
iu	=	0
on_ioerror, endwhil
while not eof(lun) do begin
	if iu ge in then stop,'more than 1000 data-points'
	; no temperature record
	tt	=	0.
	hf	=	0.
	if iw eq 6 then 					$
		readf,lun,qxt,qyt,qzt,et,mint,it		$
	else begin
		if iw eq 7 then begin
		  if readword(junk,4) eq 'T-act' then  		$				$
		    ; w/ T record
		    readf,lun,qxt,qyt,qzt,et,tt,mint,it 	$
		  else if readword(junk,4) eq 'H-Field' then  	$				$
		    ; w/ H record
		    readf,lun,qxt,qyt,qzt,et,hf,mint,it
		end else readf,lun,qxt,qyt,qzt,et,tt,hf,mint,it
	end
	dede(iu,0)	=	et
	dede(iu,1)	=	it
	if keyword_set(gaussan) then dede(iu,2)	= gauss(it) else $
	dede(iu,2)	=	sqrt(it)
	dede(iu,3)	=	qxt
	dede(iu,4)	=	qyt
	dede(iu,5)	=	qzt
	dede(iu,6)	=	tt
	dede(iu,7)	=	hf
	dede(iu,8)	=	mint

	; asd data
	readf,lun,tempasd
	asd(iu,*)	=	tempasd
	iu	=	iu+1
endwhil:
endwhile
free_lun,lun
dede	=	dede(0:iu-1,*)
asd	=	asd(0:iu-1,*)

;----------------------------------------
;| generating the dat structure		|
;----------------------------------------
gendast,d,3,26,9,iu,npix,/asd

if iu ne npt then begin
	;print,'(FROM rnistq.pro) # of data points is different ' $
	;	+'from the # shown on top'
	;print,'                  of the file. Is this an aborted file?'
endif


d.inorm	=	0
inorm		=	d.inorm
d.tnvh(inorm)=	'monitor'
d.tnvh(1)	=	'RM collim'
d.tnvh(2)	=	'MS collim'
d.tnvh(3)	=	'SA collim'
d.tnvh(4)	=	'AD collim'
d.tnvh(5)	=	efixt
d.tnvh(6)	=	'hw center'
d.tnvh(7)	=	'hc'
d.tnvh(8)	=	'kc'
d.tnvh(9)	=	'H field'
d.tnvh(10)	=	'mon mosaic'
d.tnvh(11)	=	'samp mosaic'
d.tnvh(12)	=	'ana mosaic'
d.tnvh(13)	=	'tau monochromator'
d.tnvh(14)	=	'tau analyzer'
d.tnvh(15)	=	'hw step'
d.tnvh(16)	=	'dh'
d.tnvh(17)	=	'dk'
d.tnvh(18)	=	'dl'
d.tnvh(19)	=	'phi'
d.tnvh(20)	=	'a'
d.tnvh(21)	=	'b'
d.tnvh(22)	=	'c'
d.tnvh(23)	=	'alfa'
d.tnvh(24)	=	'beta'
d.tnvh(25)	=	'gamma'

d.unvh(inorm)	=	'counts'
d.unvh(1)		=	'min'
d.unvh(2)		=	'min'
d.unvh(3)		=	'min'
d.unvh(4)		=	'min'
d.unvh(5)		=	'meV'
d.unvh(6)		=	'mev'
d.unvh(7)		=	'rlu'
d.unvh(8)		=	'rlu'
d.unvh(9)		=	'Tesla'
d.unvh(10)		=	'min'
d.unvh(11)		=	'min'
d.unvh(12)		=	'min'
d.unvh(13)		=	'AA^-1'
d.unvh(14)		=	'AA^-1'
d.unvh(15)		=	'mev'
d.unvh(16)		=	'rlu'
d.unvh(17)		=	'rlu'
d.unvh(18)		=	'rlu'
d.unvh(19)	=	'deg'
d.unvh(20)	=	'AA'
d.unvh(21)	=	'AA'
d.unvh(22)	=	'AA'
d.unvh(23)	=	'deg'
d.unvh(24)	=	'deg'
d.unvh(25)	=	'deg'

d.tsvh(0)	=	'title'
d.tsvh(1)	=	'filename'
d.tsvh(2)	=	'date'

d.tde(0)		=	'E'
d.tde(1)		=	'intensity'
d.tde(2)		=	'error'
d.tde(3)		=	'h'
d.tde(4)		=	'k'
d.tde(5)		=	'l'
d.tde(6)		=	'T'
d.tde(7)		=	'Hfield'
d.tde(8)		=	'time'

d.ude(0)		=	'meV'
d.ude(1)		=	'counts'
d.ude(2)		=	'counts'
d.ude(3)		=	'rlu'
d.ude(4)		=	'rlu'
d.ude(5)		=	'rlu'
d.ude(6)		=	'K'
d.ude(7)		=	'Tesla'
d.ude(8)		=	'min'



;_________________________________________________
;| transfer header data to output data-structure |
;|_______________________________________________|
d.svh(0)	=	tit
d.svh(1)	=	fnam
d.svh(2)	=	date
d.scan	=	scanty


if scanty eq 'TIME' then begin
	d.tnvh(inorm)	=	'time'
	d.unvh(inorm)	=	'seconds'
endif

d.nvh(inorm)	=	mon			;monitor
d.mon	=	mon			;monitor
d.nvh(1)	=	col0			;collimations
d.nvh(2)	=	col1
d.nvh(3)	=	col2
d.nvh(4)	=	col3
d.nvh(5)	=	def
d.nvh(6)	=	dec
d.nvh(7)	=	dqc0
d.nvh(8)	=	dqc1
d.nvh(9)	=	dhfld
d.nvh(10)	=	msm
d.nvh(11)	=	mss
d.nvh(12)	=	msa
d.nvh(13)	=	taum
d.nvh(14)	=	taua
d.nvh(15)	=	dde
d.nvh(16)	=	ddq0
d.nvh(17)	=	ddq1
d.nvh(18)	=	ddq2
d.nvh(19)	=	dangle
d.nvh(20)	=	aa
d.nvh(21)	=	bb
d.nvh(22)	=	cc
d.nvh(23)	=	alfa
d.nvh(24)	=	beta
d.nvh(25)	=	gama

d.de(*,*)		=	dede(*,*)
d.asd(*,*)		=	asd(*,*)
d.dasd(*,*)		=	sqrt(asd(*,*))

;________________________________________________
;|						|
;|selecting the x,y axis			|
;|______________________________________________|
if n_elements(xtt) eq 0 then sxya,d
saxis,d,xtitle=xtt,ytitle=ytt

if d.tde(0) eq 'E' then begin
	d.tnvh(6)		=	'lc'
	d.unvh(6)		=	'rlu'
	d.nvh(6)		=	dqc2
endif else if d.tde(0) eq 'h' then begin
	d.tnvh(7)		=	'lc'
	d.unvh(7)		=	'rlu'
	d.nvh(7)		=	dqc2
endif else if d.tde(0) eq 'k' then begin
	d.tnvh(8)		=	'lc'
	d.unvh(8)		=	'rlu'
	d.nvh(8)		=	dqc2
endif
end



pro rasdq,filename,d,gaussian=gaussian,xtitle=xtt,ytitle=ytt,ct=ct
;----------------------------------------------------------------
;| Purpose	: read the data files with one Ei		|
;|			into data structure			|
;|								|
;| Input	:						|
;|	-- filename, string array for filenames			|
;|	-- xtt,	string for the x title				|
;|	-- ytt,	string for the y title				|
;| 								|
;| External	:						|
;|	-- rasdq.pro	&	combasd.pro  or subtasd.pro	|
;| 								|
;|
;| Modifications :						|
;|	Name modified 2/13/93 by Collin Broholm also		|
;|	keyword changed to gassian not gaussan			|
;----------------------------------------------------------------
common comwn,nwarno,nwartn
common comws,nwarts

nwartn		=	0
nwarts		=	0
nwarno		=	0
nfile		=	n_elements(filename)

	roneasdq,filename(0),d,xtitle=xtt,ytitle=ytt
	strdu,d
if nfile le 1 then goto,onefile
for i=1,nfile-1 do begin
	roneasdq,filename(i),datao,xtitle=xtt,ytitle=ytt
	strdu,datao
	merge,d,datao,d1
	d	=	d1
endfor


onefile:
end

pro roneasda,file_name,d,xtitle=xtitle,ytitle=ytitle

compile_opt idl2
;------------------------------------------------------------------------
;|									|
;| Purpose	: Read ASD data-file of the format which is produced    |
;|		  by the NIST neutron spectrometer controle program 	|
;|		  ICP const-I buffer				    	|
;|									|
;| Input	: file-name, the data file			    	|
;| Output	: data, the data structure 				|
;| Externals	: gendast.pro					    	|
;| 									|
;| NOTE 	:							|
;| 	Angles of A4, 2thita, is assign to the horizontal axis	        |
;|	in this program							|
;------------------------------------------------------------------------

in			=	1000
junk			=	''
dfile			=	''
ddate			=	''
scanty			=	''
scantybase		=	''
npts			=	0
dtype			=	''
dtitle			=	''
dcollimation		=	intarr(4)
dmosaic			=	intarr(3)
ddet			=	intarr(1)

;------------------------------------------------
;| reading the headers			  	|
;------------------------------------------------

openr,lun,file_name,/get_lun
readf,lun,format='(x,a12,3x,a17,3x,a1,5x,f8.0,f7.0,1x,a4,2x,i4,3x,a3,2x)',$
      dfile,ddate,scanty,ddmon,prefact,scantybase,npts,dtype
dmon	=	ddmon*prefact
readf,lun,junk
readf,lun,format='(a100)',dtitle
readf,lun,dcollimation,dmosaic,dlamb,dtmpst,dtinc,dhfld,ddet
readf,lun,junk

;--------------------------------
;| start reading actual data 	|
;--------------------------------

;------------------------
;|  read angles		|
;------------------------
tt		=	fltarr(4,6)		;theta table
ttl		=	fltarr(4)
for i=0,5 do begin
	readf,lun,ttl
	tt[*,i]	=	ttl
endfor

readf,lun,junk
readf,lun,format='(x,a12,8x,i4)',junk,npix
readf,lun,junk

; asd data format
tempasd	=	fltarr(npix)
asd	=	fltarr(in,npix)

;Count the number of columns to be read. Assume standard set of columns.
iw	=	0
tiw	=	strarr(100)
while ( readword(junk,iw) ne '') do begin
	iw	=	iw+1
	tiw[iw-1]	=	readword(junk,iw-1)
end
tiw	=	tiw[0:iw-1]

;------------------------
;|  read intensities	|
;------------------------
itt	=	fltarr(in)
minin	=	fltarr(in)
tempar	=	fltarr(in)
tmp	=	fltarr(iw)
dtmp	=	fltarr(in,iw)
iu	=	0
on_ioerror, endwhil
while not eof(lun) do begin
	readf,lun,tmp
	dtmp[iu,*]	=	tmp
	; asd data
	readf,lun,tempasd
	asd[iu,*]	=	tempasd

	iu		=	iu+1
	if iu ge 1000 then stop,'# of point is more than 1000'
endwhil:
endwhile
free_lun,lun

dtmp			=	dtmp[0:iu-1,*]
asd			=	asd[0:iu-1,*]

if iu ne npts then begin
	;print,'(FROM rasda.pro) # of data points is different ' $
	;	+'from the # shown on top'
	;print,'                  of the file. Is this an aborted file?'
endif
;------------------------------------------------
;| convert angle to real angle steps        	|
;------------------------------------------------
ary		=	fltarr(iu,6)		; arry of number of point


for la=0,5 do begin
	astp	=	tt[2,la]         	;angle step
	ma	=	tt[3,la]		;max angle
	mi	=	tt[1,la]		;min angle
	for lab=0,iu-1 do ary[lab,la]=mi+lab*astp
endfor


;________________________________________________
;|						|
;| start to generate the data structure		|
;|______________________________________________|
lis	=	where(tiw eq 'TEMP',ntem)
lis	=	where(tiw eq 'H-Field',nhf)

gendast,d,3,12,9+ntem,iu,npix,/asd
if ntem then begin
	if ntem then gendast,d,3,12,9+ntem+nhf,iu,npix,/asd	$
	else gendast,d,3,12,9+nhf,iu,npix,/asd
end

d.tde[0]		=	'A4'
d.ude[0]		=	'degree'
d.tde[1]		=	'COUNTS'
d.ude[1]		=	'counts'
d.tde[2]		=	'error'
d.ude[2]		=	'counts'
d.tde[3]		=	'A2'
d.ude[3]		=	'degree'
d.tde[4]		=	'A3'
d.ude[4]		=	'degree'
d.tde[5]		=	'A5'
d.ude[5]		=	'degree'
d.tde[6]		=	'A6'
d.ude[6]		=	'degree'
d.tde[7]		=	'A1'
d.ude[7]		=	'degree'
d.tde[8]		=	'MIN'
d.ude[8]		=	'min.'
if ntem then begin
	d.tde[9]	=	'TEMP'
	d.ude[9]	=	'K'
endif

if nhf then begin
	d.tde[n_elements(d.tde)-1]	=	'H-Field'
	d.ude[n_elements(d.tde)-1]	=	'Tesla'
endif

for i=0,n_elements(tiw)-1 do begin
	d.de[*,where(d.tde eq tiw[i])]	=	dtmp[*,i]
end
d.de[*,2]		=	sqrt(d.de[*,1])
d.tde[1]		=	'Intensity'

; store angles
d.de[*,0]		=	ary[*,3]
d.de[*,3]		=	ary[*,1]
d.de[*,4]		=	ary[*,2]
d.de[*,5]		=	ary[*,4]
d.de[*,6]		=	ary[*,5]
d.de[*,7]		=	ary[*,0]

; store ASD data
d.asd[*,*]		=	asd[*,*]
d.dasd[*,*]		=	sqrt(asd[*,*])

;________________________________________________
;|						|
;|selecting the x,y axis			|
;|______________________________________________|
if n_elements(xtitle) eq 0 then sxya,d
saxis,d,xtitle=xtitle,ytitle=ytitle

d.inorm			=		0
inorm				=		d.inorm
d.nvh[inorm]			=		dmon
d.mon			=		dmon
if scantybase eq 'TIME' then begin
	d.tnvh[inorm]	=		'time'
	d.unvh[inorm]	=		'seconds'
endif else begin
	d.tnvh[inorm]	=		'monitor'
	d.unvh[inorm]	=		'counts'
endelse

d.tsvh[0]		=	'title'
d.tsvh[1]		=	'filename'
d.tsvh[2]		=	'date'
d.svh[0]		=	dtitle
d.svh[1]		=	dfile
d.svh[1]	=	ddate
d.scan		=	scanty

d.tnvh[1]		=	'wavelength'
d.unvh[1]		=	'AA^-1'
d.nvh[1]		=	dlamb
d.tnvh[2]		=	'H field'
d.unvh[2]		=	'Tesla'
d.nvh[2]		=	dhfld
d.tnvh[3]		=	'RM collim'
d.unvh[3]		=	'minutes of arc'
d.nvh[3]		=	dcollimation[0]
d.tnvh[4]		=	'MS collim'
d.unvh[4]		=	'minutes of arc'
d.nvh[4]		=	dcollimation[1]
d.tnvh[5]		=	'SA collim'
d.unvh[5]		=	'minutes of arc'
d.nvh[5]		=	dcollimation[2]
d.tnvh[6]		=	'AD collim'
d.unvh[6]		=	'minutes of arc'
d.nvh[6]		=	dcollimation[3]
d.tnvh[7]		=	'Ti'
d.unvh[7]		=	'K'
d.nvh[7]		=	dtmpst
d.tnvh[8]		=	'delt T'
d.unvh[8]		=	'K'
d.nvh[8]		=	dtinc
d.tnvh[9]		=	'mon mosaic'
d.unvh[9]		=	'minutes of arc'
d.nvh[9]		=	dmosaic[0]
d.tnvh[10]		=	'samp mosaic'
d.unvh[10]		=	'minutes of arc'
d.nvh[10]		=	dmosaic[1]
d.tnvh[11]		=	'ana mosaic'
d.unvh[11]		=	'minutes of arc'
d.nvh[11]		=	dmosaic[2]



lastline:
end



pro rasda,filename,d,xtitle=xtitle,ytitle=ytitle
;________________________________________________________________
;| Purpose	: read the data files into data structure	|
;|								|
;| Input	:						|
;|	-- filename, string array for filenames			|
;| 								|
;| External	:						|
;|	-- ronenista.pro	&	comb.pro  or subt.pro	|
;| 								|
;| 								|
;| Modifications :						|
;|	Name modified 2/13/93 by Collin Broholm also		|
;|	keyword changed to gassian not gaussan			|
;|______________________________________________________________|
common comwn,nwarno,nwartn
common comws,nwarts

nwartn		=	0
nwarts		=	0
nwarno		=	0
nfile		=	n_elements(filename)

	roneasda,filename(0),d,xtitle=xtitle,ytitle=ytitle
	strdu,d
if nfile le 1 then goto,onefile
for i=1,nfile-1 do begin
	roneasda,filename(i),datao,xtitle=xtitle,ytitle=ytitle
	strdu,datao
	merge,d,datao,d1
	d	=	d1
endfor


onefile:
end

pro subtasd,d1,d2,d,tol=tol
;--------------------------------------------------------
; Purpose:	perform d=d1-d2			|
;--------------------------------------------------------

mon1	=	d1.mon
mon2	=	d2.mon
fac	=	mon1/mon2

if n_elements(tol) ne 1 then tol=1e-4*(max(d1.de(*,0))-min(d1.de(*,0)))
nds	=	n_elements(d1.de(*,0))
npix	=	n_elements(d1.asd(0,*))

d	=	d1
j	=	0

for i=0,nds-1 do begin
	bgpts	=	where(abs(d1.de(i,0)-d2.de(*,0)) le tol,nbgpts)
	if nbgpts gt 0 then begin
	 d.asd(j,*)	=	d1.asd(j,*)			$
				-total(d2.asd(bgpts,*),1)	$
			       *fac/nbgpts


	 d.dasd(j,*)	=	sqrt(d1.dasd(j,*)^2		$
			      +total(d2.dasd(bgpts,*)^2,1)	$
			      	*fac^2/nbgpts^2)

	 ;j	=	j+1
	end else begin
		a41	=	d1.de(j,where(d1.tde eq 'A4'))
	dis	=	abs(d2.de(*,where(d2.tde eq 'A4'))-a41)
	eso	=	sort(dis)
	 d.asd(j,*)	=	mon1*(d1.asd(j,*)/mon1		$
			      -total(d2.asd(eso(0),*),1)/mon2)
	 d.dasd(j,*)	=	sqrt(d1.dasd(j,*)^2		$
			      +total(d2.dasd(eso(0),*)^2,1)	$
			      	*(mon1/mon2)^2)

	end

j	=	j+1

end


end


pro strdu,d
;________________________________________________________________
;|								|
;| Routine to get rid of the empty space of the stings in 	|
;| the data structure						|
;|______________________________________________________________|
d.tsvh	=	strtrim(d.tsvh,2)
d.svh	=	strtrim(d.svh,2)
d.tnvh	=	strtrim(d.tnvh,2)
d.unvh	=	strtrim(d.unvh,2)
d.tde	=	strtrim(d.tde,2)
d.ude	=	strtrim(d.ude,2)
end

pro scantype,file_name,scan
;____________________________________________________________________
;|								    |
;| Purpose	: return which NIST icp buffer created the data     |
;|                file	    					    |
;|								    |
;|								    |
;| Input	: file_name, the file to be read		    |
;|								    |
;|__________________________________________________________________|

junk	=	''

openr,lun,file_name,/get_lun
;________________________________________________
;|						|
;| read in header data for of the 1st line 	|
;|______________________________________________|

readf,lun,junk
junk		=	strtrim(junk,2)
scan		=	strmid(junk,36,1)
free_lun,lun

end

pro saxis,d,xtitle=xtitle,ytitle=ytitle
;________________________________________________________
;|							|
;| Routine to choose horizental and vertical variables	|
;| according to the xtitle and ytitle from the input	|
;| keyword. If no keywords supplied, the data structure	|
;| will remain the same.				|
;|							|
;| This commond is easily applide after overv,data	|
;| to get available string names of x or y title 	|
;| 							|
;| Input :						|
;|	- data, the data structure			|
;|	- xtitle, string name for the horizontal title	|
;|	- ytitle, string name for the vertical title	|
;|							|
;| Output :						|
;| 	- data, the data.de(*,0) and data.de(*,1) will	|
;|		be changed with reference to xtitle and	|
;|		ytitle string.				|
;|							|
;| Attention:						|
;|	If string name of ytitle is given, its errors	|
;|	might have to be figured out. data.de(*,2)	|
;|	is the array for the errors of y's		|
;|______________________________________________________|

dedd				=	fltarr(d.ndp,d.nde)
dedd(*,*)			=	d.de(*,*)

if n_elements(xtitle) ne 0 then begin
	itxx			=	where(d.tde eq xtitle)
	itx			=	itxx(0,0)
	if itx lt 0 then begin
	      print,' selected x title string not exist in the data structure'
		print,'use overv to overview the data element titles'
		 goto,noxtit
	endif
	tde0			=	d.tde(0)
	ude0			=	d.ude(0)
	d.de(*,0)		=	dedd(*,itx)
	d.ude(0)		=	d.ude(itx)
	d.tde(0)		=	d.tde(itx)
	d.de(*,itx)		=	dedd(*,0)
	d.tde(itx)		=	tde0
	d.ude(itx)		=	ude0
endif
noxtit:
if n_elements(ytitle) ne 0 then begin
	ityy			=	where(d.tde eq ytitle)
	ity			=	ityy(0,0)
	if ity lt 0 then begin
           print,' selected y title string not exist in the data structure'
		print,'use overv to overview the data element titles'
	 goto,lastline
	endif
	tde1			=	d.tde(1)
	ude1			=	d.ude(1)
	d.de(*,1)		=	dedd(*,ity)
	d.ude(1)		=	d.ude(ity)
	d.tde(1)		=	d.tde(ity)
	d.tde(ity)		=	tde1
	d.ude(ity)		=	ude1
	d.de(*,ity)		=	dedd(*,1)
endif
lastline:
end


function normf,d
;----------------------------------------------------------------
;| return normalization factor if present. If not return 0	|
;|								|
;|	modification :						|
;|	Created by Collin Broholm 2/14/93			|
;|								|
;----------------------------------------------------------------

inorm	=	d.inorm
if inorm ge 0 and inorm lt d.nnvh then			$
	return,d.nvh(inorm)					$
else return,0

end

pro merge,d1,d2,d,append=append,tol=tol,mon=mon
;
; merge two ASD data structures into d
;

if not keyword_set(tol) then tol=1.e-4

npix1	=	n_elements(d1.asd(0,*))
npix2	=	n_elements(d2.asd(0,*))
if npix1 ne npix2 then $
	stop,'two data have different # of pixels! -- from merge.pro'

no	=	d1.ndp+d2.ndp
gendast,d,max([d1.nsvh,d2.nsvh])	$
         ,max([d1.nnvh,d2.nnvh])	$
         ,max([d1.nde,d2.nde])	$
         ,no,npix1,/asd

; header
stringheader,d,d1,d2

; merge data
d.de(0:d1.ndp-1,0:d1.nde-1)	=	d1.de
d.de(d1.ndp:no-1,0:d2.nde-1)	=	d2.de
d.asd(0:d1.ndp-1,*)	=	d1.asd
d.asd(d1.ndp:no-1,*)	=	d2.asd
d.dasd(0:d1.ndp-1,*)	=	d1.dasd
d.dasd(d1.ndp:no-1,*)	=	d2.dasd
d.q(0:d1.ndp-1,*)	=	d1.q
d.q(d1.ndp:no-1,*)	=	d2.q
d.hw(0:d1.ndp-1,*)	=	d1.hw
d.hw(d1.ndp:no-1,*)	=	d2.hw
d.mon			=	d1.mon
d.scan			=	d1.scan

if keyword_set(append) then begin
	d.asd(d1.ndp:no-1,*)	=	d2.asd*d1.mon/d2.mon
	d.dasd(d1.ndp:no-1,*)	=	d2.dasd*d1.mon/d2.mon
return
end

; variables are d1.de(*,0) and d2.de(*,0)

mon1	=	d1.mon+fltarr(d1.ndp)
mon2	=	d2.mon+fltarr(d2.ndp)
mona	=	[mon1,mon2]
if not keyword_set(mon) then mon=d1.mon

;
; sort data according to the scaning variable
eso	=	sort(d.de(*,0))
d.de	=	d.de(eso,*)
d.asd	=	d.asd(eso,*)
d.dasd	=	d.dasd(eso,*)
d.q	=	d.q(eso,*)
d.hw	=	d.hw(eso,*)
mona	=	mona(eso)
for i=0,n_elements(eso)-1 do $
	d.dasd(eso(i),*)=(d.dasd(eso(i),*)*mona(i))^2
nscan	=	1.+fltarr(no)	; # of scans for the points

emon	=	mona^2
j	=	-1
for i=1,no-1 do begin
	j	=	j+1

	if (d.de(i,0)-d.de(j,0)) le tol then begin
		nscan(i)	=	0.  ; to delete the merged data later
		nscan(j)	=	nscan(j)+1
		d.de(j,0)	=	(d.de(j,0)+d.de(i,0))/2.
		mona(j)		=	mona(j)+mona(i)
		emon(j)		=	emon(j)+emon(i)
		d.asd(j,*)	=	d.asd(j,*)+d.asd(i,*)
		d.dasd(j,*)	=	d.dasd(j,*)+d.dasd(i,*)
		j	=	j-1

	end else j=i-1
end

newset	=	where(nscan ne 0,no)
dt	=	d
gendast,d,max([d1.nsvh,d2.nsvh])	$
         ,max([d1.nnvh,d2.nnvh])	$
         ,max([d1.nde,d2.nde])	$
         ,no,npix1,/asd
d.de	=	dt.de(newset,*)
d.q	=	dt.q(newset,*)
d.hw	=	dt.hw(newset,*)

d.mon	=	mon
for i=0,no-1 do begin
	d.asd(i,*)	=	dt.asd(newset(i),*)*mon/mona(newset(i))
	d.dasd(i,*)	=	sqrt(dt.dasd(newset(i),*))	$
					/sqrt(emon(newset(i)))
end

end

pro dumpheader,d1,d2
;________________________________________________
;|						|
;| demp the string headers of d1 into d2	|
;|______________________________________________|

; header
d2.tsvh	=	d1.tsvh
d2.svh	=	d1.svh
d2.tnvh	=	d1.tnvh
d2.unvh	=	d1.unvh
d2.nvh	=	d1.nvh
d2.tde	=	d1.tde
d2.ude	=	d1.ude
d2.mon	=	d1.mon
d2.scan	=	d1.scan


end
pro combbkgd,bg1,bg2,ttb2,bg
;------------------------------------------------
;| combine two bkgd data into one		|
;------------------------------------------------

monb	=	normf(bg1)
rescale,bg2,monb,/asd
cutdat,bg1,[0,ttb2]
cutdat,bg2,[ttb2+1.e-4,500]


merge,bg1,bg2,bg,/append
bg.tde	=	bg1.tde

end
pro gendast,d,nsvhn,nnvhn,nden,ndpn,npixn,asd=asd
;------------------------------------------------------------------------
;|									|
;| definition of general data storage structure consisting of   	|
;|	svh  : 	string variables in header at nsvh point		|
;|	       	the LESS important strings should be input with		|
;|		LARGER array-pointer number -- nsvh			|
;|	nvh  : 	numerical variables in header				|
;|	       	the LESS important numbers should be input with		|
;|		LARGER array-pointer number -- nnvh			|
;|	 de  : 	data elements measured at ndp data points		|
;|	ndp  :  actual number of data point				|
;|    inorm  :  index for the intensity normalization reference. 	|
;|		(   	e.g. if its monitor rate then 			|
;|		  	data.tnvh(.data.inorm)='mon'			|
;|		 	data.unvh(data.inorm)='count' 		)	|
;|									|
;| each variable has a title and in addition				|
;| each numerical variable has a name and a unit stored			|
;|									|
;| input elements:							|
;|	nsvhn : # of string headers, stored in data.nsvh		|
;|	nnvhn : # of numerical headers, stored in data.nnvh		|
;|      nden  : # of data elements, stored in data.nde			|
;|	ndpn  : # of data points, stored in data.nsvh			|
;|	npixn  : # of pixel points of ASD, stored in data.npix		|
;|									|
;| If the above input elements are not provided, the default values	|
;| of 8,20,8,50 will be used.						|
;------------------------------------------------------------------------

;----------------------------------------
;| default value of nsvh, nnvh, nde	|
;----------------------------------------
if n_elements(nsvht) eq 0 then nsvht=8
if n_elements(nnvht) eq 0 then nnvht=20
if n_elements(ndet) eq 0 then ndet=8
if n_elements(ndpt) eq 0 then ndpt=50

;----------------------------------------
;| the data structure			|
;----------------------------------------

if keyword_set(asd) then 	$
   d	=	{nsvh:nsvhn,npix:npixn,nnvh:nnvhn,nde:nden,ndp:ndpn	$
		,inorm:-1,tsvh:strarr(nsvhn),svh:strarr(nsvhn)		$
		,tnvh:strarr(nnvhn),unvh:strarr(nnvhn)			$
		,nvh:fltarr(nnvhn),tde:strarr(nden),ude:strarr(nden)	$
		,de:fltarr(ndpn,nden),mon:1.,scan:' '			$
		,asd:fltarr(ndpn,npixn),dasd:fltarr(ndpn,npixn)		$
		,q:fltarr(ndpn,npixn),hw:fltarr(ndpn,npixn)		$
		,qpar:fltarr(ndpn,npixn),qper:fltarr(ndpn,npixn)}	$
else				$
   d	=	{nsvh:nsvhn,nnvh:nnvhn,nde:nden,ndp:ndpn	$
		,inorm:-1,tsvh:strarr(nsvhn),svh:strarr(nsvhn)		$
		,tnvh:strarr(nnvhn),unvh:strarr(nnvhn)			$
		,nvh:fltarr(nnvhn),tde:strarr(nden),ude:strarr(nden)	$
		,de:fltarr(ndpn,nden),mon:1.,scan:' '}

end
pro cutdat,d,range,asd=asd
;
; return ASD data which variable is within the range
;

if n_elements(asd) gt 0 and n_elements(asd) ne 2	$
	then stop,'asdrange has to have two elements'
if n_elements(asd) eq 2 then begin
	npix	=	asd(1)-asd(0)+1
	gendast,dat,d.nsvh,d.nnvh,d.nde,d.ndp,npix,/asd
; header
	dat.mon		=	d.mon
	dat.tsvh	=	d.tsvh
	dat.svh		=	d.svh
	dat.tnvh	=	d.tnvh
	dat.unvh	=	d.unvh
	dat.nvh		=	d.nvh
	dat.tde		=	d.tde
	dat.ude		=	d.ude

; data
	dat.de		=	d.de
	dat.asd		=	d.asd(*,asd(0):asd(1))
	dat.dasd	=	d.dasd(*,asd(0):asd(1))
	dat.q		=	d.q(*,asd(0):asd(1))
	dat.qpar	=	d.qpar(*,asd(0):asd(1))
	dat.qper	=	d.qper(*,asd(0):asd(1))
	dat.hw		=	d.hw(*,asd(0):asd(1))
goto,done
end


if n_elements(range) ne 2 then 	$
	stop,'provide the range you want: cutdat,d,range'

lis 	= 	where(d.de(*,0) ge range(0) and d.de(*,0) le range(1),no)

gendast,dat,d.nsvh,d.nnvh,d.nde,no,n_elements(d.asd(0,*)),/asd

; header
dat.mon		=	d.mon
dat.tsvh	=	d.tsvh
dat.svh		=	d.svh
dat.tnvh	=	d.tnvh
dat.unvh	=	d.unvh
dat.nvh		=	d.nvh
dat.tde		=	d.tde
dat.ude		=	d.ude


; data
dat.de		=	d.de(lis,*)
dat.asd		=	d.asd(lis,*)
dat.dasd	=	d.dasd(lis,*)
dat.q		=	d.q(lis,*)
dat.qpar	=	d.qpar(lis,*)
dat.qper	=	d.qper(lis,*)
dat.hw		=	d.hw(lis,*)

done:
d	=	dat

end

pro qbuftoqe,filename,d,asd=asd,monorm=monorm,nosens=nosens,xtit=xtit
;
; read Q-buffer ASD file and convert to (q,e)
; this routine assumes that the lattice angles are all 90 degree
;

if n_elements(asd) ne 2 then asd=[7,244]
if n_elements(asd) ne 2 then asd=[7,244]

;*	read in raw data 	*
readasd,filename,d

if n_elements(monorm) ne 1 then monorm=d.mon

ih	=	where(d.tde eq 'h')
ik	=	where(d.tde eq 'k')
il	=	where(d.tde eq 'l')
ie	=	where(d.tde eq 'E')

d.asd	=	d.asd/d.mon*monorm
d.dasd	=	d.dasd/d.mon*monorm


pg002 = 1.87325

;calfil_file = file_which('calfil.dat', /include_current_dir)
calfil_file = !DAVE_AUXILIARY_DIR+'calfil.dat'

openr,lun, calfil_file,/get_lun
readf,lun,npix
ef	=	fltarr(npix)
sens	=	fltarr(npix)
readf,lun,ef
readf,lun,sens
free_lun,lun

as	=	2*!pi/d.nvh(where(d.tnvh eq 'a'))
bs	=	2*!pi/d.nvh(where(d.tnvh eq 'b'))
cs	=	2*!pi/d.nvh(where(d.tnvh eq 'c'))
efix	=	d.nvh(5)	; Ef or Ei fixed
if n_elements(efix) gt 1 then efix	=	efix(0)

for i=0,d.ndp-1 do begin
  	ei	=	efix+d.de(i,ie)
	qtran	=	sqrt((d.de(i,ih)*as)^2	$
			+(d.de(i,ik)*bs)^2+(d.de(i,il)*cs)^2)
;	if n_elements(qtran) gt 1 then qtran=total(qtran)/n_elements(qtran)
	tts0	=	acos((ei+efix-2.0717*qtran^2)/2./sqrt(ei*efix))
  	dtt	=	asin(pg002/2./sqrt(ef/2.0717))		$
	       		-asin(pg002/2./sqrt(ef(127)/2.0717))
	d.hw(i,*)	=	ei-ef
	d.q(i,*)	=	sqrt( ( ei+ef-2*sqrt(ei*ef)*Cos(tts0+dtt)) $
			 	/ 2.0717)
    	kfdkfix	=	sqrt(ef/efix)
    if not keyword_set(nosens) then begin
    	d.asd(i,*) = 	d.asd(i,*)/kfdkfix/(1.e-8+sens)
    	d.dasd(i,*) = 	d.dasd(i,*)/kfdkfix/(1.e-8+sens)
    end

end

cutdat,d,asd=asd

end


pro ibuftoqe,filename,d,asd=asd				$
	,a4=a4,back1=back1,ttmin=ttmin,nosens=nosens	$
	,back2=back2,ttb2=ttb2,tol=tol,monorm=monorm,xtit=xtit
;
; read i-buffer ASD file and convert A4 to (q,e)
;

if n_elements(ttmin) ne 1 then ttmin=7
if n_elements(ttb2) ne 2 then ttb2=25
; pr min for Ef=3.15meV w/o in-pile collimator
if n_elements(asd) ne 2 then asd=[7,244]
if n_elements(xtit) ne 1 then xtit='A4'

;*	read in raw data 	*
if n_elements(back1) ne 0 and n_elements(back2) ne 0 and n_elements(ttb2) ne 0$
        then begin
	readasd,filename,dd,xtitle=xtit
	if n_elements(dd.de(*,0)) eq 1 then a4=[dd.de(*,0)]	$
		else a4=dd.de(*,0)
	mon	=	dd.mon

	readasd,back1,bg1,xtitle=xtit
	bg1.asd	=	bg1.asd*mon/bg1.mon
	bg1.dasd=	bg1.dasd*mon/bg1.mon
	readasd,back2,bg2,xtitle=xtit
	bg2.asd	=	bg2.asd*mon/bg2.mon
	bg2.dasd=	bg2.dasd*mon/bg2.mon
	combbkgd,bg1,bg2,ttb2,bg

	if n_elements(tol) ne 1 then 	$
		tol=1e-4*(max(dd.de(*,0))-min(dd.de(*,0)))
	if total(bg2.asd) eq 0 then 	$
		print,'from ibuftoqe.pro: bkgd=0, something wrong?'

	subtasd,dd,bg,d,tol=tol
	cutdat,d,[ttmin,200]
	if n_elements(monorm) ne 1 then monorm=d.mon
	d.asd	=	d.asd*monorm/mon
	d.dasd	=	d.dasd*monorm/mon
end else begin
	readasd,filename,d,xtitle=xtit
	if n_elements(d.de(*,0)) eq 1 then a4=[d.de(*,0)]	$
		else a4=d.de(*,0)
	mon	=	normf(d)
	cutdat,d,[ttmin,200]
	if n_elements(monorm) ne 1 then monorm=d.mon
	d.asd	=	d.asd/mon*monorm	; intensity
	d.dasd	=	d.dasd/mon*monorm	; error
end

pg002 = 1.87325

;	calfil_path = file_which( 'calfil.dat' )
; openr,lun, calfil_path ,/get_lun

;if file_which('calfil.dat', /include_current_dir) eq '' then begin
;	calfil_file = 'calfil.dat'
;endif else begin
;	calfil_file = file_which('calfil.dat', /include_current_dir)
;endelse
calfil_file = !DAVE_AUXILIARY_DIR+'calfil.dat'
openr,lun, calfil_file,/get_lun
readf,lun,npix
ef	=	fltarr(npix)
sens	=	fltarr(npix)
readf,lun,ef
readf,lun,sens
free_lun,lun

ei	=	2.0717*(pg002/2./sin(d.de(0,where(d.tde eq 'A1'))*!dtor))^2

dtt	=	asin(pg002/2./sqrt(ef/2.0717))		$
	       		-asin(pg002/2./sqrt(ef(127)/2.0717))
oneset	=	1+fltarr(n_elements(a4))
onepix	=	1+fltarr(npix)
d.q	=	sqrt( (ei+oneset#ef-2*oneset#sqrt(ei*ef)	$
			*Cos(a4#onepix*!dtor+oneset#dtt))/2.0717)
d.hw	=	ei-oneset#ef

;**********************************************
;* perform sensitivity correction if required *
;**********************************************
if not keyword_set(nosens) then begin
	divmat	=	oneset#((1.e-8+sens)*sqrt(ef/ef(127)))
    	d.asd	= 	d.asd/divmat
    	d.dasd 	= 	d.dasd/divmat
end

cutdat,d,asd=asd

end


pro readasd,file_name,dd,xtitle=xtt,ytitle=ytt,ct=ct
;____________________________________________________________________
;|								    |
;| Purpose	: Read ASD data file of the format which is produced|
;|		  by the NIST neutron spectrometer controle program |
;|		  ICP  const-Q or const-I buffer		    |
;|								    |
;|								    |
;| Input	: file_name, the file to be read		    |
;| Output	: data, the data structure			    |
;| externals	: gendast, to generate data structure		    |
;|								    |
;|__________________________________________________________________|

junk	=	''

openr,lun,file_name(0),/get_lun
;________________________________________________
;|						|
;| read in header data for of the 1st line 	|
;|______________________________________________|

readf,lun,junk
junk		=	strtrim(junk,2)
scan		=	strmid(junk,36,1)
jm0		=	strmid(junk,0,8)
jm1		=	strmid(junk,17,8)
free_lun,lun

if (scan eq 'Q') or (scan eq 'T') then 				$
rasdq,file_name,dd,xtitle=xtt,ytitle=ytt,ct=ct		$
else if scan eq 'I' then					$
rasda,file_name,dd,xtitle=xtt,ytitle=ytt			$
;else if scan eq 'B' then					$
;rasdb,file_name,dd,xtitle=xtt,ytitle=ytt			$
else print,' Data file type not recognized. Has format changed ?' $
		+' (FROM rnist)'

end


; READ ASD FILES
pro rasdfiles,files,da $
	,asd=asd,back1=back1,back2=back2	$
	,ttb=ttb,tol=tol,mon=mon,xtit=xtit

nfiles	=	n_elements(files)
if n_elements(asd) ne 2 then asd=[40,210]
if n_elements(ttb) ne 2 then ttb=25

scantype,files(0),scan

if scan eq 'Q' then proname='qbuftoqe'
if scan eq 'I' then proname='ibuftoqe'

for i=0,nfiles-1 do begin
	scantype,files(i),scani
	if scani ne scan then begin
		errarray = ['Error caught: Files with different scan types']
		a = dialog_message(errarray,/error)
	return
	endif
endfor

if proname eq 'ibuftoqe' then goto,ibuf	$
else if proname eq 'qbuftoqe' then goto,qbuf

qbuf:
;print,'read file generated from q-buffer'

call_procedure,proname,files(0),d,asd=asd,xtit=xtit

gendast,da,d.nsvh,d.nnvh,d.nde,d.ndp*50,d.npix,/asd
if n_elements(mon) eq 0 then mon=d.mon

ndp	=	0
for i=0,nfiles-1 do begin
	call_procedure,proname,files(i),d,asd=asd,monorm=mon ,xtit=xtit
	lis	=	ndp+indgen(d.ndp)
	da.de(lis,*)		=	d.de
	da.q(lis,*)		=	d.q
	da.hw(lis,*)		=	d.hw
	da.asd(lis,*)		=	d.asd
	da.dasd(lis,*)		=	d.dasd
	ndp	=	ndp+d.ndp
end

gendast,db,d.nsvh,d.nnvh,d.nde,ndp,d.npix,/asd
dumpheader,d,db
db.asd	=	-1e30
db.tde	=	d.tde
db.de		=	da.de(0:ndp-1,*)
db.q		=	da.q(0:ndp-1,*)
db.hw		=	da.hw(0:ndp-1,*)
db.asd		=	da.asd(0:ndp-1,*)
db.dasd		=	da.dasd(0:ndp-1,*)
da	=	db

goto,done

ibuf:
; print,'read file generated from I-buffer'

bk1	=	strarr(nfiles)
bk2	=	strarr(nfiles)
if n_elements(back1) ne 0 then begin
  if n_elements(back1) eq 1 then bk1(*)=back1	$
	else bk1=back1
  if n_elements(back2) eq 1 then bk2(*)=back2	$
	else bk2=back2
endif

call_procedure,proname,files(0),d,asd=asd,monorm=mon,xtit=xtit

if n_elements(back1) ne 0 then begin
  print,'from rasdfiles.pro, signal files=',files(0)
  print,'from rasdfiles.pro, bkgd files=',bk1(0),bk2(0)
  if n_elements(tol) eq 1 then 	$
  call_procedure,proname,files(0),d,asd=asd,back1=bk1(0),back2=bk2(0)	$
	,ttb=ttb,tol=tol,xtit=xtit else 	$
  call_procedure,proname,files(0),d,asd=asd,back1=bk1(0),back2=bk2(0)	$
	,ttb=ttb,xtit=xtit
endif else begin
  call_procedure,proname,files(0),d,asd=asd,xtit=xtit
end
if n_elements(mon) eq 0 then mon=d.mon
d.asd	=	d.asd*mon/d.mon
d.dasd	=	d.dasd*mon/d.mon

gendast,da,d.nsvh,d.nnvh,d.nde,d.ndp,d.npix*nfiles,/asd
dumpheader,d,da
da.asd	=	-1e30
da.tde			=	d.tde
da.de			=	d.de
da.q(*,0:d.npix-1)	=	d.q
da.hw(*,0:d.npix-1)	=	d.hw
da.asd(*,0:d.npix-1)	=	d.asd
da.dasd(*,0:d.npix-1)	=	d.dasd
npix0	=	d.npix

for i=1,nfiles-1 do begin
 if n_elements(back1) ne 0 then begin
  print,'from rasdfiles.pro, signal and bkgd files=',files(i),bk1(i),bk2(i)
  if n_elements(tol) eq 1 then $
  call_procedure,proname,files(i),d,asd=asd,back1=bk1(i),back2=bk2(i)	$
	,ttb=ttb,tol=tol,monorm=mon,xtit=xtit else 	$
  call_procedure,proname,files(i),d,asd=asd,back1=bk1(i),back2=bk2(i)	$
	,ttb=ttb,monorm=mon,xtit=xtit
 endif else begin
  if n_elements(tol) eq 1 then $
  call_procedure,proname,files(i),d,asd=asd,tol=tol,monorm=mon,xtit=xtit $
   else call_procedure,proname,files(i),d,asd=asd,monorm=mon,xtit=xtit
 end

	ib	=	npix0*i
	ie	=	ib+npix0-1
	setr	=	indgen(n_elements(d.q(*,0)))
	da.q(setr,ib:ie)		=	d.q
	da.hw(setr,ib:ie)		=	d.hw
	da.asd(setr,ib:ie)		=	d.asd
	da.dasd(setr,ib:ie)		=	d.dasd
end

done:
da.mon	=	mon

end

