;$Id: trifenestra__createwidgets.pro,v 1.9 2004/02/12 21:31:56 jmspark Exp $
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
pro createwidgets_event,event
   if dave_set_focus(event) then return
   message, 'Createwidgets_event is being in use.', /continue
   message, 'What a surprise!', /continue
   message, 'From now on, forward this event to updateImageEvent.', /continue

   widget_control, event.top, get_uvalue=self
   self -> updateImage

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************

;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
pro trifenestra::createwidgets

   ; Constants for Window Sizes
   cxsize = 400 & cysize = 400 ; Central Window Sizes
   lpxsize = 265 ; Left Panel X Size (Y Size is the same as cysize)

   ; Remember the window sizes.
   self.xsize = cxsize
   self.ysize = cysize
   self.xsize_lp = lpxsize
   self.ysize_lp = cysize
   self.xsize_bp = cxsize
   self.ysize_bp = lpxsize

   ; Choose the tlb for either stand alone or DAVE version.
   tit = 'Trifenestra ' + strtrim( string( !trifenestra.version ), 2 ) + ' alpha'
   if (*self.daveStatePtr).runFlag eq 0 then begin ; Stand alone

     tit = tit + ' (' + !trifenestra.date + ')'
     tlb = widget_base(/row ,tit=tit,mbar=menubar, /tlb_size_events)

   endif else begin ; Run under Dave environment.

     tit = tit + ' - DAVE project @ NIST Center for Neutron Research'
     tlb = widget_base(/row, title = tit, mbar=menubar $
      , group_leader = (*self.daveStatePtr).group_leader )
   endelse


   ; Create the widget hierarchy.

   ; ********************************** Menu Items
   wfilemenu = trifenestra_file( menubar )

   wWindowMenu = trifenestra_window_menu( menubar )

   ; ********************************** BASES
   leftbase = widget_base(tlb, /col, event_pro = 'trifenestra_event')
   rightbase = widget_base(tlb, /col)

   ; ********************************** LEFT Base
   ; titleBase = trifenestra_titleBase( leftbase )


   ; ********************************** Right Base
   upperBase = widget_base(rightbase,/row)
   bottomBase = widget_base(rightbase,/row)

   ; Left Panel
   lpdrawid = trifenestra_leftPanelBase(upperbase,lpxsize,cysize)

   ; Central Window
   cdrawid = trifenestra_cWindowBase( upperbase, cxsize, cysize )

   ; Bottom Left Base
   bottomleftbase = widget_base(bottombase,/row,xsize=lpxsize,ysize=lpxsize)

   ; Divide the bottom left base into two rows.
   self -> widgets, trifenestra_imagebase( bottomleftbase )
   self -> widgets, trifenestra_transformBase( bottomleftbase )

   ; Bottom Window
   bpdrawid = trifenestra_BottomPanelBase( bottombase, cxsize, lpxsize )


   ; Place the widget at the center of the screen.
   void = pos_widget(tlb)

   ; Realize the widget hierarchy.
   widget_control,tlb,/realize

   ; Remember widget IDs
   self.tlb = tlb
   !trifenestra.wTrife = tlb
   self.leftbase = leftbase

   ; Remember Window IDs
   widget_control,cdrawid, get_value=cwinid
   widget_control,lpdrawid,get_value=lpwinid
   widget_control,bpdrawid,get_value=bpwinid
   self.cwinid = cwinid
   self.lpwinid = lpwinid
   self.bpwinid = bpwinid

   ; Create Pixmap windows & remember their IDs.
   window,/free,/pixmap,xs=cxsize,ys=cysize
   self.pixmapid = !d.window
   window,/free,/pixmap,xs=lpxsize,ys=cysize
   self.pixmapid_lp = !d.window
   window,/free,/pixmap,xs=cxsize,ys=lpxsize
   self.pixmapid_bp = !d.window

   ; Store the object reference at the top level base.
   widget_control,tlb,set_uvalue=self
   ret = dave_set_focus(tlb)
   xmanager $
     , 'createwidgets' $
     , tlb $
     , /no_block $
     , cleanup='trifenestra_cleanup' $
     , event_handler='createwidgets_event'

   !trifenestra.wControlWindow = trifenestra_control_window( tlb )
   !trifenestra.wCommandWindow = trifenestra_command_window( tlb )

   return

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
