;$Id: trifenestra_iybase.pro,v 1.3 2003/06/11 15:29:33 jmspark Exp $
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
;
;	Top Left Window for I vs Y			|
;

pro oivsyDraw,event
widget_control,event.top,get_uvalue=self
self -> doupdateivsy
return
end

;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
pro trifenestra::updateivsy

if n_elements(*self.y_lp) lt 2 then begin
	errarray = ['Error caught: No data available']
	a = dialog_message(errarray,/error)
	return
endif

	idl_state_restore, !trifenestra.leftPanelState

	; Set values in the IY Base
	wYMin = 'iy_ymin'
	wYMax =  'iy_ymax'
	self -> widget_control, wYMin, set_value = !y.range[0]
	self -> widget_control, wYMax, set_value = !y.range[1]
	wIMin =  'iy_Imin'
	wIMax = 'iy_Imax'
	self -> widget_control, wIMin, set_value = !x.range[0]
	self -> widget_control, wIMax, set_value = !x.range[1]

wset,self.pixmapid_lp


if !x.range[1] eq !x.range[0] then begin
	!x.range[1] = !x.range[1] * 3d / 2d
	!x.range[0] = !x.range[0] / 2d
endif

plot,*self.y_lp,*self.x_lp	$
	,xran=!x.range,ytit=self.ytitle,xtitle='I' $
	,yran=!y.range,xticks=2,pos=[.25,.2,.9,.9]	$
	,xmargin=[1,0],ystyle=1,psym=self.iy_plot_symbol

errbarxy,*self.y_lp,*self.dy_lp,*self.x_lp, thick = 1.5

wset,self.lpwinid
device,copy=[0,0,self.xsize_lp,self.ysize_lp,0,0,self.pixMapid_lp] ; clean picture

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
pro trifenestra::doupdateivsy

	idl_state_restore, !trifenestra.leftPanelState
	; !x = *self.bangx_lp
	; !y = *self.bangy_lp

	xminid = 'xmin'
	xmaxid ='xmax'
	self -> widget_control,xminid,get_value=xmin
	self -> widget_control,xmaxid,get_value=xmax

	self.oDave -> get_range, xrange=xrange

	if xmin lt xrange[0] then xmin=xrange[0]
	if xmax gt xrange[1] then xmax=xrange[1]
	self -> widget_control,xminid,set_value=xmin
	self -> widget_control,xmaxid,set_value=xmax

	if xmin ge xmax then begin
		errarray = ['Error caught: xmin > xmax']
		a = dialog_message(errarray,/error)
		return
	endif

	self.oDave -> get, qty=qty, err=err, xdata=x, ydata=y

	if ( self.iy_use_raw_y ) then begin
		range_arr = x ge xmin and x le xmax
		eo = y[0,*]
		rio = total( (qty * range_arr), 1 ) / total( range_arr, 1 ) * ( xmax - xmin )
		drio = sqrt( total( ( err * range_arr )^2, 1 ) ) / total( range_arr, 1) * ( xmax - xmin )
	endif else begin
		ive, x, y, qty, err, eo, rio, drio, qran=[xmin, xmax]
	endelse

	; ive,*self.q,*self.hw,*self.intensity,*self.error,eo,rio,drio,qran=[xmin,xmax]

	*self.x_lp = eo
	*self.y_lp = rio
	*self.dy_lp = drio
	!trifenestra.leftPanelState.bang_x.range = $
		[min(*self.y_lp),max(*self.y_lp)]
	self -> updateivsy

return
end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************

;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
;----------- Toggle to fix or release the range of Intensity
;            when the cursor on the image plot moves

pro trifenestra::fix_i_range_lpevent, event

	strings = [ 'Fix I Range', 'Release I Range' ]


	self.togirange_lp = 1 - self.togirange_lp

	; fixirange_lp = widget_info(self.tlb,find_by_uname='fixirange_lp')
	widget_control, event.id ,set_value=strings[ self.togirange_lp ]

	return
end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
pro trifenestra::iy_ymin, event

	widget_control, event.id, get_value = ymin
	!trifenestra.leftPanelState.bang_y.range[0] = ymin

	self -> updateivsy

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
pro trifenestra::iy_ymax, event

	widget_control, event.id, get_value = ymax
	!trifenestra.leftPanelState.bang_y.range[1] = ymax

	self -> updateivsy

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
pro trifenestra::iy_Imin, event

	widget_control, event.id, get_value = Imin
	!trifenestra.leftPanelState.bang_x.range[0] = Imin
	self -> updateivsy

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
pro trifenestra::iy_Imax, event

	widget_control, event.id, get_value = Imax
	!trifenestra.leftPanelState.bang_x.range[1] = Imax
	self -> updateivsy

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
pro trifenestra::iy_use_raw_y, event

	strings = [  'Show Raw Y', 'Show Equispaced Y'  ]
	self.iy_use_raw_y = 1 - self.iy_use_raw_y

	; fixirange_bp = widget_info(self.tlb,find_by_uname='fixirange_bp')
	widget_control, event.id, set_value = strings[ self.iy_use_raw_y ]

	return


end

;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
function trifenestra_IYBase, base

	I_Y = widget_base( base $
		, /col $
		, /frame $
		, event_pro = 'oivsyDraw' )

	I_Y_label = widget_label( I_Y $
		, value='I(Y)'	$
		, /align_center $
		, font='helvetica*14*bold')

	I_Y_xbounds = widget_base( I_Y $
		, /row )

	!trifenestra.self -> widgets,  cw_field( I_Y_xbounds $
		, tit='X min'	$
		, value=1. $
		, uname='xmin' $
		, /column $
		, xsize = 7 $
		, /return_events $
		, /floating)

	!trifenestra.self -> widgets, cw_field( I_Y_xbounds $
		, tit='X max'	$
		, value=1. $
		, uname='xmax' $
		, xsize = 7 $
		, /column $
		, /return_events $
		, /floating)

	I_Y_ybounds = widget_base( I_Y $
		, /row $
		, event_pro = 'trifenestra_event' )

	!trifenestra.self -> widgets, cw_field( I_Y_ybounds $
		, tit='Y min'	$
		, value=1. $
		, uname='iy_ymin' $
		, uvalue='iy_ymin' $
		, /column $
		, xsize = 7 $
		, /return_events $
		, /floating)

	!trifenestra.self -> widgets, cw_field( I_Y_ybounds $
		, tit='Y max'	$
		, value=1. $
		, uname='iy_ymax' $
		, uvalue='iy_ymax' $
		, xsize = 7 $
		, /column $
		, /return_events $
		, /floating)

	I_Y_Ibounds = widget_base( I_Y $
		, /row $
		, event_pro = 'trifenestra_event' )

	!trifenestra.self -> widgets, cw_field( I_Y_Ibounds $
		, tit='I min'	$
		, value=1. $
		, uname='iy_Imin' $
		, uvalue='iy_Imin' $
		, /column $
		, xsize = 7 $
		, /return_events $
		, /floating)

	!trifenestra.self -> widgets, cw_field( I_Y_Ibounds $
		, tit='I max'	$
		, value=1. $
		, uname='iy_Imax' $
		, uvalue='iy_Imax' $
		, xsize = 7 $
		, /column $
		, /return_events $
		, /floating)

	!trifenestra.self -> widgets, widget_button( I_Y $
	, value= 'Show Equispaced Y' $
	, uname='iy_use_raw_y' $
	, uvalue = 'iy_use_raw_y' $
	, event_pro='trifenestra_event')

	!trifenestra.self -> widgets, widget_button( I_Y $
		, value='Fix I Range' $
		, uname='fixirange_lp' $
		, uvalue = 'fix_i_range_lpevent' $
		, event_pro='trifenestra_event')

	return, I_Y

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************