; $Id: generic__helpClass_frag.pro,v 1.2 2003/08/27 13:42:52 tanya Exp $ 
;+
; NAME:
; 	generic__helclass_frag.pro
;
; PURPOSE:
; 	Fragment of method code for all classes	 <classs>::helpclass
;	 This is an internal method used only by <class>::help_obj.
;	 Insert in your class definition:
;
;	pro YourClass::helpClass, $
;	  ; Note: The following keywords are only used by internal recrusion call.
;	   helpProStr=helpProStr, helpFuncStr=helpFuncStr, $
;		class=thisClass, level=level
;
;	  @generic__helpClass_frag.pro
;	end
;
; 	This avoids cut and paste proliferation of code, perhaps.
;
;	Note again: this code fragment is only used by YourClass::help_obj.
;
; AUTHOR:
;
;       Tanya M. Riseman, Ph.D.
;               NIST Center for Neutron Research
;       100 Bureau Drive
;               Gaithersburg, MD 20899
;       Phone: (301) 975-8379
;       E-mail: tanya.riseman@nist.gov
;
; CATEGORY:
;
;       Objects. DAVE application programming.
;
; SEE ALSO:
;	<LI><A HREF="#AAA_README">AAA_README</A>
;
; MODIFICATION HISTORY:
;	 Written by Tanya Riseman, Feb 4, 2003
;-
;###########################################################################
;
; LICENSE
;
; This software is OSI Certified Open Source Software.
; OSI Certified is a certification mark of the Open Source Initiative.
;
; This software is provided "as-is", without any express or
; implied warranty. In no event will the authors be held liable
; for any damages arising from the use of this software.
;
; Permission is granted to anyone to use this software for any
; purpose, including commercial applications, and to alter it and
; redistribute it freely, subject to the following restrictions:
;
; 1. The origin of this software must not be misrepresented; you must
;    not claim you wrote the original software. If you use this software
;    in a product, an acknowledgment in the product documentation
;    would be appreciated, but is not required.
;
; 2. Altered source versions must be plainly marked as such, and must
;    not be misrepresented as being the original software.
;
; 3. This notice may not be removed or altered from any source distribution.
;
; For more information on Open Source Software, visit the Open Source
; web site: http://www.opensource.org.
;
;###########################################################################
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Frag pro generic_obj::helpClass, class=thisClass, $
;		helpProStr=helpProStr, helpFuncStr=helpFuncStr, $
;		level=level, lun=thisLun
;;;Frag pro generic_obj::helpClass, class=thisClass, helpStr=helpStr, level=level,
;;;		lun=thisLun

;Unit Attributes Name
;-2   Write, Truncate, Tty, Reserved   <stderr>
;-1   Write, Truncate, Tty, Reserved   <stdout>
;0   Read, Tty, Reserved              <stdin>
  if (n_elements(thisLun) eq 0) then begin
      lun= -1
  endif else begin
      lun = thisLun
  endelse


  if (n_elements(thisClass) EQ 0) then begin
       printf, lun, ' Need a class!'
  endif
;  if (n_elements(helpStr) EQ 0) then begin
;       printf, lun, " Need a string array from IDL's HELP!"
;  endif
  if ((n_elements(helpProStr) + n_elements(helpFuncStr) ) EQ 0) then begin
       printf, lun, " Need a string array(s) from IDL's HELP!"
  endif
  if (n_elements(level) EQ 0) then begin
       printf, lun, ' Need a level (Object hierarchy depth)!'
  endif
  if ( (n_elements(thisClass) eq 0) or $
;  	(n_elements(helpStr) eq 0) $
	((n_elements(helpProStr) + n_elements(helpFuncStr) ) EQ 0)  OR $
  	(n_elements(level) EQ 0) $
	)  then begin
    return
  endif
  
;  sLen = n_elements(helpstr)
  sProLen = n_elements(helpProStr)
  sFuncLen = n_elements(helpFuncStr)

  pad = string(strtrim(string(level), 2), ' ')
  for i = 0, level do begin	; two spaced per level
    pad = pad + '  '
  endfor
  
  if (sProLen gt 0) then begin
    classStr =  string(thisClass, '::*')
    matchArr = strmatch(helpProStr, classStr)
;    print, "sProLen = ", sProLen 
;    print,  "matchArr = ", matchArr
    printf, lun, pad, "Method Procedures:"
    for is = 0, (sProLen-1) do begin
        if (matchArr[is]) then begin
	  printf, lun, pad, helpProstr[is]
	  more = 1
	  imore = is + 1
	  if (imore EQ sProLen) then more = 0
	  while (more) do begin
;	    print, imore, ' help testing "', (helpProStr[imore]), '"'
;	    aString = helpProStr[imore]
;	    print, imore, ' help testing aString "', aString, '"'
;	    print, imore, ' help testing aString[0:3] "', aString[0:3], '"'
;;	    print, 'help testing "', (helpProStr[imore])[0:3], '"'
	    if (strcmp(helpProStr[imore], '    ', 4)) then begin
;Wrong	    if ((helpProStr[imore])[0:3] EQ '    ') then begin
	      printf, lun, pad, helpProstr[imore]
	      imore = imore + 1
	      if (imore EQ sProLen) then more = 0
	    endif else begin
	      more = 0
	    endelse
	  endwhile
	endif		
    endfor
    printf, lun, ' '
  endif     

  if (sFuncLen gt 0) then begin
    classStr =  string(thisClass, '::*')
    matchArr = strmatch(helpFuncstr, classStr)
    printf, lun, pad, "Method Functions:"
    for is = 0, (sFuncLen-1) do begin
        if (matchArr[is]) then begin
	  printf, lun, pad, helpFuncstr[is]
;	  printf, lun, '	', helpstr[is]
	  more = 1
	  imore = is + 1
	  if (imore EQ sFuncLen) then more = 0
	  while (more) do begin
	    if (strcmp(helpFuncStr[imore], '    ', 4)) then begin
;;;	    if ((helpProStr[imore])[0:3] EQ '    ') then begin
	      printf, lun, pad, helpFuncstr[imore]
	      imore = imore + 1
	      if (imore EQ sFuncLen) then more = 0
	    endif else begin
	      more = 0
	    endelse
	  endwhile
	endif		
    endfor 
    printf, lun, ' '
  endif     

;Frag end
