; $Id: icp_style.pro,v 1.2 2003/09/12 15:26:20 tanya Exp $
;+
; NAME:
; 	icp_style
;
; PURPOSE:
;	Returns 'b', 'q' or 'i' from header of the ICP triple axis data file,
; indicating the "style" of the data format.
; Might be appropriate for  other data file types.
;
; AUTHOR:
;
;       Tanya M. Riseman, Ph.D.
;       NIST Center for Neutron Research
;       100 Bureau Drive
;       Gaithersburg, MD 20899
;       Phone: (301) 975-8379
;       E-mail: tanya.riseman@nist.gov
;
; MODIFICATION HISTORY:
;
;       Written by Tanya Riseman, Spring, 2003.
;-
;================================================================================
;*
function icp_style, $ 		; Returns character 'b', 'q' or 'i'
   newFile			; filename, just for peeking
;/
  ; returns "b', 'q' or 'i' from header of the file.
  ; Expand for other data file types.
  
  infolabel = "icp_header:;style >> "  

  openr, unit, newFile, /get_lun, error = errCode
;Play  openu, unit, newFile, /get_lun, error = errCode
  IF (errCode NE 0) then begin
    ; the standard error file (logical unit -2):
    PRINT,  infolabel, !ERROR_STATE.MSG
    ;; PRINTF, -2, !ERROR_STATE.MSG
    if (arg_present(thisUnit)) then begin
      thisUnit = 0
      free_lun, unit
    endif
    return, ''
  endif

  success = 1

  aline = ''
  readf, unit, aline
  style = readword(aline, 2)

  if not((style eq 'Q') or (style eq 'B') or (style eq 'I')) then begin
    style = ''
  endif
  
;  if ((style eq 'Q') or (style eq 'B') or (style eq 'I')) then begin
;    return, style
;  endif else begin
;    return, ''
;  endelse

;Debug  print, infolabel, ' Style = ', style, ' unit =', unit
  
  close, unit, exit_status=exit_status
  free_Lun, unit
  if (exit_status NE 0) then begin
    print, infolabel, 'CLOSE exit_status=', exit_status
  endif
;debug  help, /files
;  close, unit

  return, style
  
end		; icp_style


