; $Id: launchspyspecobj.pro,v 1.3 2003/09/10 19:26:52 tanya Exp $
;+
; NAME:
;       launchSpyspecobj
;
; PURPOSE:
;
;	This is the launch manager for DAVE program button which launches 
; the specObj reduction methods, for a pre-exising DavePtr.
; This allows spying on the specific area.
;
; AUTHOR:
;	Richard Azuah, Ph.D.
;       NIST Center for Neutron Research
;       100 Bureau Drive
;       Gaithersburg, MD 20899
;
; CATEGORY:
;
;       DAVE application button.
;
; SEE ALSO:
; 	<LI><A HREF="#REDUCE_FRGD_BKGD_SPECOBJ">REDUCE_FRGD_BKGD_SPECOBJ</A>
;	<LI><A HREF="#SPECOBJ__DEFINE_arguments">SPECOBJ__DEFINE_arguments</A>
;
; MODIFICATION HISTORY:
;	Richard Azuah and Tanya Riseman, Aug 1st, 2003. 
;	TMR. Sept 8, 2003. Call REDUCE_FRGD_BKGD_SPECOBJ instead of REDUCESPYSPECOBJ
;	TMR. Sept 10, 2003. renamed REDUCE_FRGD_BKGD_SPECOBJ  REDUCESPECOBJ.
;-
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Dave launcher for Tanya's ICP data reduction
pro launchSpySpecObj, event

widget_control,event.top,get_uvalue = pState

; print, ptr_valid(pState)
;help, pstate
;help, (*pState)
;print, " launcher pState=", (*pState)

thisEvent = tag_names(event,/structure_name)
case thisEvent of

'WIDGET_BUTTON':$
  begin
      daveDeSensitizeButtons,event
      if (!debug) then davePtr_show, ((*pState).davePtr), /partial
;      reduceSpySpecObj,(*pState).davePtr,notifyIds=[event.id,event.top], $
;      	group_leader=event.top
      reduceSpecObj,(*pState).davePtr,notifyIds=[event.id,event.top], $
      	group_leader=event.top
  end

'REDUCESPECOBJEVENT': $
;'REDUCESPYSPECOBJEVENT': $
  begin
;  message, /info, string("About to enter return to Dave, event=", event)
  daveSensitizeButtons,event
  end
else:
endcase
return
end
