;+
; NAME:
;       specObj_example
;
; PURPOSE:
;
;	To test the class specObj.
;	IDL> specobj_example, 1			(1-7, 9,10, 33)
;.........................................................................
;
; AUTHOR:
;
;       Tanya M. Riseman, Ph.D.
;               NIST Center for Neutron Research
;       100 Bureau Drive
;               Gaithersburg, MD 20899
;       Phone: (301) 975-8379
;       E-mail: tanya.riseman@nist.gov
;
; MODIFICATION HISTORY:
;
;       Written by Tanya Riseman, Spring, 2003.
;
;-
;=======================================================================
;*
pro specObj_example, $ 
	whichExample, $		; Integer (1-7, 9,10, 33). 0 means all
	whichFile		; a,b,c, for example 10
;/
  infolabel = "specObj_example >> "  

 if (n_elements(whichexample) eq 0) then whichExample = 0
 if (n_elements(whichFile) eq 0) then whichFile = ''

   ;------------------------------------------------------------
 if ((whichexample eq 0) or (whichexample eq 1)) then begin

     check_heap
;Debug  help, dtree
     dtree = obj_new('specObj', label='Tree', codeSource='specObj_example1')
;Debug  help, dtree

     print, 'Starting "dtree -> add, /inHeader..."'
     dtree -> add, /inHeader, $
		; tags = [class, name, codeSource]
        tags = ['qtyObj', 'filename', 'specObj_example1'], $
     	contents=obj_new('qtyObj', name='filename', qty='cehex011.bc7' )

     dtree -> add, /inHeader, $
        tags = ['qtyObj', 'mainTitle', 'specObj_example1'], $
    	contents=obj_new('qtyObj', $
	  name= 'mainTitle', $
	  qty= ['cehex011.bc7', 'May  3 2002 00:01', 'cehex CeB6 single crystal.'], $
	  legend= ['filename', 'date', 'comments'])
	
     dtree -> add, /inHeader, $
        tags = ['qtyObj', 'date', 'specObj_example1'], $
    	contents=obj_new('qtyObj', name='date', qty= 'May  3 2002 00:01')

     dtree -> add, /inHeader, $
        tags = ['qtyObj', 'scanStyle', 'specObj_example1'], $
     	contents=obj_new('qtyObj', name='scanStyle', qty='Q' )

     dtree -> add, /inHeader, $
        tags = ['qtyObj', 'collimation', 'specObj_example1'], $
     	contents=obj_new('qtyObj', name='collimation', $
		qty=[60, 60, 20, 99] )

     dtree -> add, /inHeader, $
        tags = ['qtyObj', 'latDim', 'specObj_example1'], $
     	contents=obj_new('qtyObj', name='Lattice Dimensions', $
	  qty=[4.141, 4.141, 4.141],units='AA', legend = ['a', 'b', 'c'] )

     dtree -> add, /inHeader, $
        tags = ['qtyObj', 'latAngles', 'specObj_example1'], $
     	contents=obj_new('qtyObj', name='Lattice Angles', $
	  qty=[90.000, 90.000, 90.000], units='degrees', $
	   legend = ['alpha', 'beta', 'gamma'] )

     dtree -> add, /inHeader, $
        tags = ['qtyObj', 'Q_center', 'specObj_example1'], $
     	contents=obj_new('qtyObj', name='Q_center', $
	;; err is the step size
	  qty=[0.250, 0.250, 0.500], err=[ 0.0000, 0.0000, 0.0000 ], $
	  units='degrees', legend = ['h', 'k', 'l'] )

     dtree -> add, /inHeader, $
        tags = ['qtyObj', 'T_start', 'specObj_example1'], $
     	contents=obj_new('qtyObj', name='Temperature Set Point', $
	;; err is the step size
	  qty= 1.65000 , err=0.300, units='Kelvin')
;	  qty= [1.65000, 0.300], legend = ['start', 'step'],  units='Kelvin')
	  
     ;--- cut --------------  	 
     dtree -> add, /inHeader, $
        tags = ['qtyObj', 'specific_cut', 'specObj_example1'], $
     	contents=obj_new('qtyObj', name='Energy', $
	  qty= 1.75000 , units='meV', legend = 'y')
     ;--- cut --------------  	 
  	 

     print, 'Starting "dtree -> add, /inData..."'
     dtree -> add, /inData, $
        tags = ['qtyObj', 'T-act', 'specObj_example1'], $
     	contents=obj_new('qtyObj', name='Temperature, measured', $
	  qty=[ 1.536, 1.5477, 1.574, 1.5991, 1.6165, 1.6551], units = 'Kelvin')

     dtree -> add, /inData, $
        tags = ['qtyObj', 'min', 'specObj_example1'], $
     	contents=obj_new('qtyObj', name='Length of measurement', $
	  qty=[ 5.12, 5.08, 5.10, 5.12, 5.13, 5.17], units = 'Minutes')

     cqty = [1465, 1427, 1419, 1392, 1416, 1412]
     cerr = sqrt(cqty)
     dtree -> add, /inData, $
        tags = ['qtyObj', 'Counts', 'specObj_example1'], $
     	contents=obj_new('qtyObj', name='Neutron Counts', $
	  qty=cqty, err=cerr, units = 'Events')

;Debug  help, dtree
     print, 'Starting "dtree -> setFocus, ..."'

;    dtree -> setFocus, $ 
;        mainTitleTags = ['qtyObj', 'mainTitle', 'specObj_example1'], $
;;	descripTags = ['qtyObj', 'Q_center', 'specObj_example1'], $ 
;;	descripLegend = 'h', $
;	descripTags = ['qtyObj', 'T_start', 'specObj_example1'], $ 
;	descripLegend = '', $
;	cutTags = ['qtyObj', 'specific_cut', 'specObj_example1'], $
;   	xTags = ['qtyObj', 'T-act', 'specObj_example1'], $
;   	zTags = ['qtyObj', 'Counts', 'specObj_example1']

    print, "dtree -> setFocus, mainTitleTags = ..., " 
    dtree -> setFocus, $ 
        mainTitleTags = ['qtyObj', 'mainTitle', 'specObj_example1']
    print, "dtree -> setFocus, descripTags = ..., descripLegend = ..."
    dtree -> setFocus, $ 
	descripTags = ['qtyObj', 'T_start', 'specObj_example1'], $ 
	descripLegend = ''
    print, "dtree -> setFocus, cutTags = ..."
    dtree -> setFocus, $ 
	cutTags = ['qtyObj', 'specific_cut', 'specObj_example1']

    print, "dtree -> setFocus, xTags=..., zTags = ..." 
    dtree -> setFocus, $ 
   	xTags = ['qtyObj', 'T-act', 'specObj_example1'], $
   	zTags = ['qtyObj', 'Counts', 'specObj_example1']


;Debug help, dtree
    print
    print, 'Starting "report_obj, dtree, ..."'
    report_obj, dtree, 'info_specObj.txt', /heapNum
    print, "report_obj, dtree, 'info_specObj.txt', /heapNum------------------"
    print 
    
;    newfile = 'info_specObj.txt'
;    print, "newfile = 'info_specObj.txt'"
;    openw, localLun, newFile, /get_lun, error = errCode
;    IF (errCode NE 0) then begin
;      ; the standard error file (logical unit -2):
;      PRINT,  !ERROR_STATE.MSG
;    endif
;    printf, locallun, 'IDL> specObj_example, 1'
;    printf, localLun, localLun, '=localLun. output file = ', newFile
;    printf, locallun, '------------------------------------------'
;    printf, locallun
;
;    print
;    print, '-------------------------------------'
;    dtree -> show, /recursive, /heapNum	
;    print, 'dtree -> show, /recursive, /heapNum'
;    print, '-------------------------------------'
;    print
;        	

;Debug  help, dtree

    dtree -> show, /focus	
    print, 'dtree -> show, /focus'
    print, '-------------------------------------'
    print
   
;    printf, locallun, 'dtree ->print_obj, lun=locallun, /alsoPtrs'
;    printf, locallun
;    dtree -> print_obj, lun=locallun, /alsoPtrs	
;    printf, locallun, '-------------------------------------'
;    printf, locallun	
;    print, 'dtree ->print_obj, lun=locallun, /alsoPtrs'
;    print, '-------------------------------------'
;    print
        	
;    printf, locallun, 'dtree ->help_obj,lun=locallun, /methodsOnly'
;    printf, locallun
;    dtree -> help_obj,  lun=locallun, /methodsOnly	
;    printf, locallun, '-------------------------------------'
;    printf, locallun	
;    print, 'dtree ->help_obj,lun=locallun, /methodsOnly'
;    print, '-------------------------------------'
;    print

;    print, '-------------------------------------'
;    printf, locallun, 'dtree -> show, /recursive, lun=locallun'
;    printf, locallun
;    dtree -> show, /recursive, lun=locallun
;    printf, locallun, '-------------------------------------'
;    printf, locallun	
;    print, 'dtree -> show, /recursive, lun=locallun'
;    print, '-------------------------------------'

        	
;Debug   help, dtree

    dtree -> plot
    print, 'dTree -> plot'
;    dtree -> plotxz
;    print, 'dTree -> plotxz'
    print, '-------------------------------------'
    print	    	

;    close, locallun, exit_status=exit_status
;    free_lun, locallun
;    if (exit_status NE 0) then begin
;      print, infolabel, localLun, 'CLOSE exit_status=', exit_status
;    endif
;    locallun = 0
    
 endif

;Debug   help, dtree

 
;  check_heap

  ;------------------------------------------------------------

   ;------------------------------------------------------------
  if ((whichexample eq 0) or (whichexample eq 2)) then begin
     dtree = obj_new('specObj', label='Tree-ICP', codeSource='specObj_example2')
     currentFile = '../sample_data/lacam009.bt9'
;     myLun = -1
;     myLun = 0
     OK = func_icp_header_init( dtree, $
		filename=currentFile,$
     		 lun=Lun_ex2, /close, /skipInPlane) 
; Don't use callFunction because it requires that all keywords are pass by value.
; We want the value lun=lun_ex2 to be returned.
;     OK = dtree -> callFunction( 'func_icp_header_init', dtree, $
;		filename=currentFile,$
;     		 lun=Lun_ex2, /close, /skipInPlane)
    print, "OK = dtree -> callFunction('func_icp_header_init',", currentFile, ') --------------'
    if (n_elements(Lun_ex2) GT 0) then begin 
      print, " Lun_ex2 = ", Lun_ex2
    endif else begin
      print, "n_elements(Lun_ex2)=", n_elements(Lun_ex2)
    endelse
    
    print, '-------------------------------------'

    ; Eventually make a widget which adds items to the specObject.
    dtree -> add, $
    	tags = ['qtyObj', 'new_item', 'specObj_example2'], $
  	contents=obj_new('qtyObj', name='new_item', $
		qty=['A new item', 'add nauseum'], $
		legend=['a', 'b'])
    
    OK = dtree -> getField(['*', 'temp_scan', '*'], /inheader, $
    		qty = mytemps, units=myUnits)
    print, 'myTemps = ', myTemps, "  myUnits=", myUnits
    print, 'OK = dtree -> getField(...)  --------------------------'

    OK = dtree -> setField(['*', 'temp_scan', '*'], /inheader, $
    		qty = 333.3, units='Nonsense units')
    print, 'OK = dtree -> setField(...)  --------------------------'

    dtree -> show, /recursive	
    print, 'dtree -> show, /recursive --------------------------'
    print, '-------------------------------------'
    
  endif 			;; whichexample eq 2
 
   ;------------------------------------------------------------
  if ((whichexample eq 0) or (whichexample eq 3)) then begin
     dtree = obj_new('specObj', label='Tree-ICP-whole', codeSource='specObj_example3')
     currentFile = '../sample_data/lacam009.bt9'
     myLun = 0
     ; All keywrods are pass by value, so this is OK.
;     OK = func_icp_data_init( dtree, $
;		currentFile,$
;     		/noConstruct, /noprune) 
     OK = dtree -> callFunction( 'func_icp_data_init', dtree, $
		currentFile,$
     		/noConstruct, /noprune) 
    print, "OK = dtree -> callFunction('func_icp_data_init', ", currentFile, ') --------------'
    print, '-------------------------------------'

    ; Eventually make a widget which adds items to the specObject.
    dtree -> add, $
    	tags = ['qtyObj', 'new_item', 'specObj_example2'], $
  	contents=obj_new('qtyObj', name='new_item', $
		qty=['A new item', 'add nauseum'], $
		legend=['a', 'b'])
    
    OK = dtree -> getField(['*', 'temp_scan', '*'], /inheader, $
    		qty = mytemps, units=myUnits)
    print, 'myTemps = ', myTemps, "  myUnits=", myUnits
    print, 'OK = dtree -> getField(...)  --------------------------'

    OK = dtree -> setField(['*', 'temp_scan', '*'], /inheader, $
    		qty = 333.3, units='Nonsense units')
    print, 'OK = dtree -> setField(...)  --------------------------'
    print

    dtree -> remove, position = ['*', 'temp_scan', '*'], /inheader, /destroy, $
     	errMsg = anErrmsg
    print, "dtree -> remove,.. errMsg=", anErrMsg, ' ---------------------'
    print
        
    dtree -> show, /recursive	
    print, 'dtree -> show, /recursive --------------------------'

    dtree -> remove, position = ['*', 'Q(h)', '*'], /inData, /destroy, $
     	/ifDataConstant, errMsg = anErrmsg
    dtree -> remove, position = ['*', 'Q(k)', '*'], /inData, /destroy, $
     	/ifDataConstant, errMsg = anErrmsg
    dtree -> remove, position = ['*', 'Q(l)', '*'], /inData, /destroy, $
     	/ifDataConstant, errMsg = anErrmsg
    print, "dtree -> remove, .... /ifDataConstant, .. errMsg=", anErrMsg, ' ---------------------'
    print
        
    dtree -> show, /recursive	
    print, 'dtree -> show, /recursive --------------------------'
    print, '-------------------------------------'
    print 
    
  endif 			;; whichexample eq 3
 
 ;---------------------------------------------------
   ;------------------------------------------------------------
  if ((whichexample eq 0) or (whichexample eq 33)) then begin
     dtree = obj_new('specObj', label='Tree-ICP-whole', $
	     codeSource='specObj_example6')
     currentFile = '../sample_data/lacam009.bt9'
     myLun = 0
     ; All keywrods are pass by value, so this is OK.
     OK = dtree -> callFunction( 'func_icp_data_init', dtree, $
		currentFile,$
     		/noprune) 
    print, "OK = dtree -> callFunction('func_icp_data_init', ", currentFile, ') --------------'
    print, '-------------------------------------'

    dtree -> show, /recursive	
    print, 'dtree -> show, /recursive --------------------------'

    dtree -> remove, /all, /inData,  /destroy, $
     	/ifDataConstant, errMsg = anErrmsg
    print, "dtree -> remove, /all, /ifDataConstant, /inData,   .. errMsg=", anErrMsg, ' ---------------------'
    print
        
    dtree -> show, /recursive	
    print, 'dtree -> show, /recursive --------------------------'
    print, '-------------------------------------'
    print 
    
  endif 			;; whichexample eq 33
 
 ;---------------------------------------------------
   ;------------------------------------------------------------
  if ((whichexample eq 0) or (whichexample eq 4)) then begin
     dtree = obj_new('specObj', label='Tree-ICP-whole', $
	     codeSource='specObj_example4')
     currentFile = '../sample_data/lacam009.bt9'
     OK = dtree -> callFunction( 'func_icp_data_init', dtree, $
		currentFile)		;;,$
;;     		/noConstruct, /noprune) 
    print, "OK = dtree -> callFunction('func_icp_data_init', ", currentFile, ') --------------'
    print, '-------------------------------------'

   voidID = dialog_viewData(specObj=dtree)
   print, voidID, "=dialog_viewData, specObj=dtree" 
;   cw_viewData, specObj=dtree
;   print, "cw_viewData, specObj=dtree" 
   print
   
  endif 			;; whichexample eq 4
 
 ;---------------------------------------------------
;   ;------------------------------------------------------------
;  if ((whichexample eq 0) or (whichexample eq 44)) then begin
;     dtree = obj_new('specObj', label='Tree-ICP-whole', $
;     	codeSource='specObj_example44')
;     currentFile = '../sample_data/lacam009.bt9'
;     OK = dtree -> callFunction( 'func_icp_data_init', dtree, $
;		currentFile)		;;,$
;;;     		/noConstruct, /noprune) 
;    print, "OK = dtree -> callFunction('func_icp_data_init', ", currentFile, ') --------------'
;    print, '-------------------------------------'
;
;   voidID = dialog_viewData(specObj=dtree)
;   print, voidID, "=dialog_viewData, specObj=dtree" 
;   print
;   
;  endif 			;; whichexample eq 44
 
 ;---------------------------------------------------
   ;------------------------------------------------------------
  if ((whichexample eq 0) or (whichexample eq 5)) then begin
     dtree = obj_new('specObj', label='Tree-ICP-whole', codeSource='specObj_example3')
     currentFile = '../sample_data/lacam009.bt9'
     OK = dtree -> callFunction( 'func_icp_data_init', dtree, $
		currentFile )		;;,$
;;     		/noConstruct, /noprune) 
    print, "OK = dtree -> callFunction('func_icp_data_init', ", currentFile, ') --------------'
    print, '-------------------------------------'

   headerID = dialog_viewHeader(specObj=dtree)
   print, headerID, "=dialog_viewHeader(specObj=dtree)" 
   print
    
  endif 			;; whichexample eq 5
 
   ;------------------------------------------------------------
  if ((whichexample eq 0) or (whichexample eq 6)) then begin
     dtree = obj_new('specObj', label='Tree-ICP-whole', $
    	 codeSource='specObj_example6')
     currentFile = '../sample_data/lacam001.bt9'
     ; All keywords are pass by value, so this is OK.
     OK = dtree -> callFunction( 'func_icp_data_init', dtree, $
		currentFile) 
    print, "OK = dtree -> callFunction('func_icp_data_init', ", currentFile, ') --------------'
    print, '-------------------------------------'

    dtree -> show, /recursive	
    print, 'dtree -> show, /recursive --------------------------'

;    dtree -> remove, /all, /inData,  /destroy, $
;     	/ifDataConstant, errMsg = anErrmsg
;    print, "dtree -> remove, /all, /ifDataConstant, /inData,   .. errMsg=", anErrMsg, ' ---------------------'
;    print
        
;    dtree -> show, /recursive	
;    print, 'dtree -> show, /recursive --------------------------'
;    print, '-------------------------------------'
;    print 
 
   voidID = dialog_viewData(specObj=dtree)
   print, voidID, "=dialog_viewData, specObj=dtree" 
;     cw_viewData, specObj = dtree  
  endif 			;; whichexample eq 6
 
 ;---------------------------------------------------
   ;------------------------------------------------------------
  if ((whichexample eq 0) or (whichexample eq 77)) then begin
     showProg = 1
     dtree = obj_new('specObj', label='Tree-ICP-whole', $
    	 codeSource='specObj_example77', $
	 instrument='bt7', $
	 path = '../sample_data/', filename='cehex011.bt7', $
	 datareader='func_icp_data_init', $
	 showProgress=showProg)		;; _EXTRA keyword
    print, "dtree = obj_new('specObj',...", $
    	" filename=",'cehex011.bt7', ", dataReader= ", 'func_icp_data_init', $
		") --------------'
    print, '-------------------------------------'
 
   voidID = dialog_viewData(specObj=dtree)
   print, voidID, "=dialog_viewData, specObj=dtree" 
  endif 			;; whichexample eq 77
 
   ;------------------------------------------------------------
  if ((whichexample eq 0) or (whichexample eq 7)) then begin
     dtree = obj_new('specObj', label='Tree-ICP-whole', $
    	 codeSource='specObj_example7')
     currentFile = '../sample_data/cehex011.bt7'
     ; All keywords are pass by value, so this is OK.
     OK = dtree -> callFunction( 'func_icp_data_init', dtree, $
		currentFile) 
    print, "OK = dtree -> callFunction('func_icp_data_init', ", currentFile, ') --------------'
    print, '-------------------------------------'

;    dtree -> remove, /all, /inData,  /destroy, $
;     	/ifDataConstant, errMsg = anErrmsg
;    print, "dtree -> remove, /all, /ifDataConstant, /inData,   .. errMsg=", anErrMsg, ' ---------------------'
;    print
        
;    dtree -> show, /recursive	
;    print, 'dtree -> show, /recursive --------------------------'
;    print, '-------------------------------------'
;    print 
 
   voidID = dialog_viewData(specObj=dtree)
   print, voidID, "=dialog_viewData, specObj=dtree" 
;     cw_viewData, specObj = dtree  
  endif 			;; whichexample eq 7
 
   ;------------------------------------------------------------
   ; Postponed
;  if ((whichexample eq 0) or (whichexample eq 8)) then begin
;    goto, skip_8
;     dtree1 = obj_new('specObj', label='Tree-ICP-whole', $
;     	codeSource='specObj_example8')
;     currentFile1 = '../sample_data/lacam009.bt9'
;     
;     dtree2 = obj_new('specObj', label='Tree-ICP-whole', $
;     	codeSource='specObj_example8')
;     currentFile2 = '../sample_data/lacam001.bt9'
;
;     dtree3 = obj_new('specObj', label='Tree-ICP-whole', $
;     	codeSource='specObj_example8')
;     currentFile3 = '../sample_data/cehex011.bt7'
;     
;     OK = dtree1 -> callFunction( 'func_icp_data_init', dtree1, $
;		currentFile1)		;;,$
;     OK = dtree2 -> callFunction( 'func_icp_data_init', dtree2, $
;		currentFile2)		;;,$
;     OK = dtree3 -> callFunction( 'func_icp_data_init', dtree3, $
;		currentFile3)		;;,$
;
;;    print, "OK = dtree -> callFunction('func_icp_data_init', ", currentFile, ') --------------'
;;    print, '-------------------------------------'

;   specArray = [dtree1, dtree2, dtree3]
;   voidID = cw_viewMultiData(specObj=specArray)
;   print, voidID, "=cw_viewMultiData(specObj=[dtree1, dtree2, dtree3])" 
;   print
;   
;    print, '-------------------------------------'
;    obj_destroy, dtree1
;    obj_destroy, dtree2
;    obj_destroy, dtree3
;    print, "obj_destroy, dtree1, dtree2, dtree3"
;    print, '-------------------------------------'
;
;  skip_8:
;  endif 			;; whichexample eq 8
 
   ;------------------------------------------------------------
  if ((whichexample eq 0) or (whichexample eq 9)) then begin
     dtree = obj_new('specObj', label='Tree-ICP-whole', $
	     codeSource='specObj_example9', wid = 1L)
     currentFile = '../sample_data/lacam009.bt9'
     OK = dtree -> callFunction( 'func_icp_data_init', dtree, $
		currentFile)		;;,$
    print, "OK = dtree -> callFunction('func_icp_data_init', ", currentFile, ') --------------'
    print, '-------------------------------------'
   
;   objArray = dtree -> get(/inHeader,  everything=headerStrArray) 
; 
;   nHeaderStr= n_elements( headerStrArray)
;   for i = 0, (nHeaderStr-1) do begin
;     print, headerStrArray[i]
;   endfor

   strArray = dtree -> textInfo(position=2, /inHeader) ; defaults to /getEverything
   print, "strArray = dtree -> textInfoHeader(position=5)"
   print, "... Defaults to /getEverything. Note: shows all values "
   print, "... /getEverything uses multiple lines per item if needed. Good for vectors. "
   nelem = n_elements(strArray)
   for i = 0, (nelem-1) do begin
     print, i, ' ', strArray[i]
   endfor
   print
   
   strArray = dtree -> textInfo(/getAll, /inHeader)
   print, "strArray = dtree -> textInfo(/getAll, /inHeader)"
   print, "... Note: Single line per item. If vector, might overflow."
   nelem = n_elements(strArray)
   for i = 0, (nelem-1) do begin
     print, i, ' ', strArray[i]
   endfor
   print

   strArray = dtree -> textInfo(/getSome, /inHeader, position = ['*', 'q_scan','*'] )
   print, "strArray = dtree -> textInfo(/getSome, /inHeader, ", $
   	"position = ['*','q_scan','*'] )"
   print, ".... Note: no values or errors shown."
   nelem = n_elements(strArray)
   for i = 0, (nelem-1) do begin
     print, i, ' ', strArray[i]
   endfor
   print
   
   strArray = dtree -> textInfo(position=['*', 'Counts', '*'], /inData)
   print, $
    " strArray = dtree -> textInfo(position=['*', 'Counts', '*'], /inData)"
   print, "... default /getEverything uses multiple lines per item if needed. Good for vectors. "
   nelem = n_elements(strArray)
   for i = 0, (nelem-1) do begin
     print, i, ' ', strArray[i]
   endfor
   print
      
   print
   
  endif 			;; whichexample eq 9
 
 ;---------------------------------------------------
   ;------------------------------------------------------------
  if ((whichexample eq 0) or (whichexample eq 10)) then begin
    currentfile = '../sample_data/20001215_02dyn.dave'
    if (whichfile eq 'a') then $
	currentfile = '../sample_data/pisarkwl_sam2SQOM.dave'
    if (whichfile eq 'b') then $
     currentfile = '../sample_data/20001215_02dyn.dave'
    if (whichfile eq 'c') then $
     currentfile = '../sample_data/vanadium_8A_sam1SSQW.dave'
     DavePtr_restore, DavePtr, currentfile
     dtree = obj_new('specObj', label='Tree-ICP-whole', $
    	 codeSource='specObj_example10', davePtr=davePtr, /convert )
    print, "DavePtr_restore, DavePtr, ", currentFile, ') --------------'
    print, "dtree = obj_new('specObj', label='Tree-ICP-whole',",  $
    	 "codeSource='specObj_example10', davePtr=davePtr , /convert ) ---------"
    print, '-------------------------------------'

    dtree -> show, /recursive
    print, 'dtree -> show, /recursive	--------------------------'
 
;    dtree -> show, /recursive, /heapNum	
;    print, 'dtree -> show, /recursive, /heapNum	--------------------------'
; 
   voidID = dialog_viewData(specObj=dtree)
   print, voidID, "=dialog_viewData, specObj=dtree" 
   
   waffle = 1
  endif 			;; whichexample eq 10
 
 ;---------------------------------------------------
   ;------------------------------------------------------------
  if ((whichexample eq 0) or (whichexample eq 11)) then begin
    fileName = 'lacam001.bt9'	; q-dependence
    fileName = 'lacam009.bt9'
    dTree = obj_new('specObj', $	; create from a TAS data file 
  	label=fileName, $
;	codeSource='Dimeo_example', $
	instrument='bt7', $
  	path = '../sample_data/', $
	filename = fileName, $
	datareader='func_icp_data_init')
;;;;	wID = wID)

;   voidID = dialog_viewData(specObj=dtree)
;   print, voidID, "=dialog_viewData, specObj=dtree" 
   print

   cloneTree = dtree -> clone()
   voidID = dialog_viewData(specObj=clonetree)
   print, voidID, "=dialog_viewData, specObj=clonetree" 

   davePtr0 = dtree -> getDavePtr()
   obj_destroy, dtree, /skipDavePtr	; Otherwise loose DavePtr too.
   davePtr_show, DavePtr0, /full
;   davePtr_cleanup, DavePtr0, /skipSpecObj	; Otherwise loose dtree too.
   print, "davePtr_show, DavePtr0, /full   -------------------
   

   davePtrclone = clonetree -> getDavePtr()
   print, "davePtr_show, DavePtrclone, /full   -------------------
   cloneRef  = DavePtr_getSpecObj(davePtrclone)
   obj_destroy,  cloneRef, /skipDavePtr
   davePtr_show, DavePtrclone, /full
   
   cloneTree -> show   
   print, ' cloneTree -> show -----------------------------'
   print
   dTree -> show   
   print, ' dTree -> show --------------------------------------'
   print
   
  endif 			;; whichexample eq 11
 

 ;---------------------------------------------------
 ;---------------------------------------------------
 ;---------------------------------------------------
  print, '-------------------------------------'
  
  if (obj_valid(dtree)) then begin
    obj_destroy, dtree
    print, "obj_destroy, dtree"
  endif

  if (obj_valid(cloneTree)) then begin
    obj_destroy, cloneTree
    print, "obj_destroy, cloneTree"
  endif

  print
    
;Debug   help, dtree

  check_heap, skip_help=waffle  
     
end		; specObj_example

