;+
; NAME:
;       tagObj_example
;
; PURPOSE:
;
;	To test the class tagObj.
;	IDL> tagobj_example
;.........................................................................
;
; AUTHOR:
;
;       Tanya M. Riseman, Ph.D.
;               NIST Center for Neutron Research
;       100 Bureau Drive
;               Gaithersburg, MD 20899
;       Phone: (301) 975-8379
;       E-mail: tanya.riseman@nist.gov
;
; MODIFICATION HISTORY:
;
;       Written by Tanya Riseman, Spring, 2003.
;
;-
;=======================================================================
;*
pro tagObj_example, $
	whichexample		; Integer for which example. 0 means all
;/
  if (n_elements(whichexample) eq 0) then whichExample = 0
  ;--------------------------------------------------------------
  if ((whichexample eq 0) or (whichexample eq 1)) then begin
   oTag1 = obj_new('tagobj', $
   	class='Class1', label='label1', codeSource='codeSource1')
   oTag1-> show
   OK  = combineTags(class='Class1b', $
   		label="label1b", codeSource='codeSource1b', $
   		tags = newTags)
   print, 'newTags = ', newTags
   OK = oTag1-> set(tags = newTags)
   print, OK, "= oTag1-> set(tags = newTags)"
   oTag1-> show
   
   print, oTag1->isHidden(), " = oTag1->isHidden()"
   print, oTag1->isAnnotated(), " = oTag1->isAnnotated()"
   OK = oTag1-> set( /annotate)
   print, oTag1->isAnnotated(), " = oTag1->isAnnotated()"
   oTag1-> show
   

   OK = oTag1-> set( /hide)
   print, oTag1->isHidden(), " = oTag1->isHidden()" 
   oTag1-> show
  
   print, oTag1->Match(class="anotherClass"), $
   	'= oTag1->Match(class="anotherClass")  '
   print, oTag1->Match(class="Class1b"), $
   	'= oTag1->Match(class="Class1b")  '
   print, oTag1->Match(class="Class1b",label="label1b",codeSource="codeSource1b"), $
   '= oTag1->Match(class="Class1b", label="label1b", codeSource="codeSource1b")' 
    
   print, oTag1->Match(class="C",label="label1b",codeSource='codeSource1b'), $
   '= oTag1->Match(class="C, label="label1b", codeSource="codeSource1b")  '
   
   print, oTag1->Match(class="Class1b",label="l",codeSource='codeSource1b'), $
   '= oTag1->Match(class="Class1b", label="l", codeSource="codeSource1b")  '
   
   print, oTag1->Match(class="Class1b",label="label1b",codeSource='c'), $
   '= oTag1->Match(class="Class1b", label="label1b", codeSource="c")'
   
   print, oTag1->Match(class="Class1b",label="label1b",codeSource='*'), $
   '= oTag1->Match(class="Class1b", label="label1b", codeSource="*")' 
   
   print, oTag1->Match(tags=["Class1b","label1b","*"]), $
   '= oTag1->Match(tags=["Class1b","label1b","*"])'


  obj_destroy, oTag1
  check_heap
   
  endif			;;  (whichexample eq 1)

  ;--------------------------------------------------------------
  if ((whichexample eq 0) or (whichexample eq 2)) then begin
   oTag1 = obj_new('tagobj', $
   	class='Class1', label='label1', codeSource='codeSource1')
	
   help, oTag1
   
   oTag1-> show
   print, "oTag1-> show   =================='
   print 

   oTag1-> print_obj
   print, "oTag1-> print_obj   =================='
   print 
   
   oTag1 -> help_obj
   print, "oTag1-> help_obj   =================='
   print 
   
   
  obj_destroy, oTag1
  
  check_heap
  endif  

  ;--------------------------------------------------------------
  if ((whichexample eq 0) or (whichexample eq 3)) then begin
   oTag1 = obj_new('tagobj', $
   	class='Class1', label='label1', codeSource='codeSource1')
	
    print, "documentation on the arguments and keywords for method tagObj::get"
   rec_doc = oTag1 -> doc('get')
   print, "rec_doc = oTag1 -> doc('get')"
   print 

;   print, rec_doc
;   print, "print, rec_doc   =================="
;   print
;   
;   help, rec_doc
;   print, "help, rec_doc   =================="
;   print
   
   printDocRec, rec_doc
   print, "printDocRec, rec_doc   =================="
   print
   
   printDocRec, rec_doc, key='annotate'
   print, "printDocRec, rec_doc, key='annotate'   =================="
   print
   
   printDocRec, rec_doc, key='argPresent'
   print, "printDocRec, rec_doc, key='argPresent'   =================="
   print
   
   ptr_free, rec_doc
   
   print, "documentation on the arguments and keywords for ALL methods in tagObj" 
   rec_doc = oTag1 -> doc()
   print, "rec_doc = oTag1 -> doc()"
   print 
   printDocRec, rec_doc
   print, "printDocRec, rec_doc,    =================="
   print

   nptr = n_elements(rec_doc)
   for i = 0, (nptr-1) do begin
     ptr_free, rec_doc[i]
   endfor 
   
  obj_destroy, oTag1
  
  check_heap
  endif  

  ;--------------------------------------------------------------
  if ((whichexample eq 0) or (whichexample eq 4)) then begin
   oTag1 = obj_new('tagobj', $
   	class='Class1', label='label1', codeSource='codeSource1')

   ; Currently file goes to current directory
   mk_html_keywords, oTag1,  'doc_tagobj__keywords.html'
   print, "mk_html_keywords called. File is doc_tagobj__keywords.html"

   mk_html_help, '/home/tanya/idl/daveNX_0305/tagobj__define.pro', $
   	'doc_tagobj__define.html'
   print, "mk_html_help called. File is doc_tagobj__define.html"


  obj_destroy, oTag1
  
  check_heap
  endif  
end

	
