; $Id: triasubs_ijk.pro,v 1.2 2003/09/12 15:24:51 tanya Exp $
;+
; NAME:
;       triasubs_ijk
;
; PURPOSE:
;
; Cycle the indices (0, 1, 2) 
;;;      subroutine ijk(i,j,k) from file generate.f
;;;      subroutine calctheta(x,y,theta) from file transform.f
;
; 	Based on Fortran routines used by spurion program.
;	These routines are used by func_icp_header_init and func_icp_data_init.
;
;.........................................................................
;
; AUTHOR:
;
;       Tanya M. Riseman, Ph.D.
;               NIST Center for Neutron Research
;       100 Bureau Drive
;               Gaithersburg, MD 20899
;       Phone: (301) 975-8379
;       E-mail: tanya.riseman@nist.gov
;
; SEE ALSO:
;	<LI><A HREF="#FUNC_ICP_DATA_INIT">FUNC_ICP_DATA_INIT</A>
;	<LI><A HREF="#FUNC_ICP_HEADER_INIT">FUNC_ICP_HEADER_INIT</A>
;	
; MODIFICATION HISTORY:
;
;       Written by Tanya Riseman, Dec 18, 2002.
;	Split func_icp_subs.pro into separate files. TMR. Aug 1, 2003
;-

;=======================================================================
;*
pro triasubs_ijk, $		; Cycle the indices (0, 1, 2) 
	i, j, k 		; The indices
;/
; Cycle the indices (0, 1, 2) 
;;;      subroutine ijk(i,j,k) from file generate.f

  case i of 
    0: begin
    	j = 1
	k = 2
    	end
    1: begin
    	j = 2
	k = 0
    	end
    2: begin
    	j = 0
	k = 1
    	end
  endcase

end			; triasubs_ijk

