; $Id: triasubs_remove_lcd.pro,v 1.2 2003/09/12 15:24:51 tanya Exp $
;+
; NAME:
;       triasubs_remove_lcd
;
; PURPOSE:
;
; Based on subroutine mult(x,y,a,b) in spurion file calclattice.f
;C find the solution to ax+by=0
;C with no common factor between a and b
; Return 0 if indeterminant, 1 if OK.
;
; 	Based on Fortran routines used by spurion program.
;	These routines are used by func_icp_header_init and func_icp_data_init.
;
;.........................................................................
;
; AUTHOR:
;
;       Tanya M. Riseman, Ph.D.
;               NIST Center for Neutron Research
;       100 Bureau Drive
;               Gaithersburg, MD 20899
;       Phone: (301) 975-8379
;       E-mail: tanya.riseman@nist.gov
;
; SEE ALSO:
;	<LI><A HREF="#FUNC_ICP_DATA_INIT">FUNC_ICP_DATA_INIT</A>
;	<LI><A HREF="#FUNC_ICP_HEADER_INIT">FUNC_ICP_HEADER_INIT</A>
;	
; MODIFICATION HISTORY:
;
;       Written by Tanya Riseman, Dec 18, 2002.
;	Split func_icp_subs.pro into separate files. TMR. Aug 1, 2003
;-

;=======================================================================
;*
function triasubs_remove_lcd,  $	; Return 0 if indeterminant, 1 if OK.
	x, y, a, b
;/

; Based on subroutine mult(x,y,a,b) in spurion file calclattice.f
;C find the solution to ax+by=0
;C with no common factor between a and b
; Return 0 if indeterminant, 1 if OK.

  debug = 0

      if ((x eq 0) and (y eq 0)) then begin
        a=0                   ; both a and b indeterminant so this
        b=0                   ; really a flag not to do any reduction
        return, 0
      endif
      
      if (x eq 0) then begin
        b=0                   ; a indeterminant
        a=1
        return, 0
      endif
      
      if (y eq 0) then begin
        a=0                   ; b indeterminant
        b=1
        return, 0
      endif

;C so a and b are determined up to some multiple and the solution
;C a=y, b=-x is fine, dump it into lcd to check for any common
;C factors
     n_vec =   [y, -x, 0]   
     triasubs_lcd, n_vec, fac
     a=n_vec[0]
     b=n_vec[1]  
     return, 1
     
end		; triasubs_remove_lcd
