; $Id: triasubs_rotate.pro,v 1.2 2003/09/12 15:24:51 tanya Exp $
;+
; NAME:
;       triasubs_rotate
;
; PURPOSE:
;
;;;      subroutine rotate(theta,i,r) from file transform.f
;C     Generates the passive transformation matrix for a 
;C     counterclockwise rotation of the axes by theta radians 
;C     about the i-th axis.
;
; 	Based on Fortran routines used by spurion program.
;	These routines are used by func_icp_header_init and func_icp_data_init.
;
;.........................................................................
;
; AUTHOR:
;
;       Tanya M. Riseman, Ph.D.
;               NIST Center for Neutron Research
;       100 Bureau Drive
;               Gaithersburg, MD 20899
;       Phone: (301) 975-8379
;       E-mail: tanya.riseman@nist.gov
;
; SEE ALSO:
;	<LI><A HREF="#FUNC_ICP_DATA_INIT">FUNC_ICP_DATA_INIT</A>
;	<LI><A HREF="#FUNC_ICP_HEADER_INIT">FUNC_ICP_HEADER_INIT</A>
;	
; MODIFICATION HISTORY:
;
;       Written by Tanya Riseman, Dec 18, 2002.
;	Split func_icp_subs.pro into separate files. TMR. Aug 1, 2003
;-

;=======================================================================
;*
function triasubs_rotate, $	; Returns the rotation matrix
	thetaRad, $		; angle in radians
	i 			; ith axis
;/
;;;      subroutine rotate(theta,i,r) from file transform.f
;C     Generates the passive transformation matrix for a 
;C     counterclockwise rotation of the axes by theta radians 
;C     about the i-th axis.

  debug = 0

    triasubs_ijk, i, j, k	; cycle the indices (0,1,2),(1,2,0),(2,0,1)
    rmatrix = make_array(3, 3, /float)
    rmatrix[i,i] = 1.0
;    rmatrix[i,j] = 0.0
;    rmatrix[i,k] = 0.0
;    rmatrix[j,i] = 0.0
    rmatrix[j,j] = cos(thetaRad)
    rmatrix[j,k] = -sin(thetaRad)
;    rmatrix[k,i] = 0.0
    rmatrix[k,j] = sin(thetaRad)
    rmatrix[k,k] = cos(thetaRad)
    
    return, rmatrix
end		;;  triasubs_rotate
