; $Id: whatsit.pro,v 1.2 2003/09/12 15:24:51 tanya Exp $
;+
; NAME:
;      whatsIt
;
; PURPOSE:
; 	 Returns string with contents of variable thingy.
; 	If a pointer or an OBJECT, return something indicating the size of the contents, 
;	 but not the contents.
;
;	Used by qtyObj__define.pro
;
; AUTHOR:
;
;       Tanya M. Riseman, Ph.D.
;       NIST Center for Neutron Research
;       100 Bureau Drive
;       Gaithersburg, MD 20899
;       Phone: (301) 975-8379
;       E-mail: tanya.riseman@nist.gov
;
; CATEGORY:
;
;	DAVE utility programming.
;
; OTHER FILES AND ROUTINES USED: 
;	format_size
; 	Objects are assumed to have the following method:
;	     OK= thingy->get(ptr_qty= thisPtr_qty, tname=thistname)
;
; EXAMPLE
;
; MODIFICATION HISTORY:
;	Created Spring, 2003. Tanya Riseman
;
;	BUILD can not resolve this properly, due to it being late in the
;	alphabet. Rename whatsIt to AAA_whatsIt. TMR. Aug 1st, 2003.
;	
;	Changed file name from AAA_whatsIt.pro to whatits.pro. TMR. Aug 6, 2003.
;-
;###########################################################################
;
; LICENSE
;
; This software is OSI Certified Open Source Software.
; OSI Certified is a certification mark of the Open Source Initiative.
;
; This software is provided "as-is", without any express or
; implied warranty. In no event will the authors be held liable
; for any damages arising from the use of this software.
;
; Permission is granted to anyone to use this software for any
; purpose, including commercial applications, and to alter it and
; redistribute it freely, subject to the following restrictions:
;
; 1. The origin of this software must not be misrepresented; you must
;    not claim you wrote the original software. If you use this software
;    in a product, an acknowledgment in the product documentation
;    would be appreciated, but is not required.
;
; 2. Altered source versions must be plainly marked as such, and must
;    not be misrepresented as being the original software.
;
; 3. This notice may not be removed or altered from any source distribution.
;
; For more information on Open Source Software, visit the Open Source
; web site: http://www.opensource.org.
;
;###########################################################################
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;=============================================================================
;*
function whatsIt, $	; returns a string with contents of the variable thingy.
	thingy		; The variable to probe.
;/
; returns string with contents of variable thingy.
; If a pointer or an OBJECT, return something indicating that, 
; but not the contents.

  if (obj_valid(thingy)) then begin
;    retString = '{OBJ}'
    if (n_elements(thingy) eq 1) then begin
      OK= thingy->get(ptr_qty= thisPtr_qty, tname=thistname)
     retString = 'OBJ' + '_' + thistname + format_size(ptr_array=thisPtr_qty)
      ptr_free, thisPtr_qty
    endif else begin
      retString = 'OBJ' + format_size(array=thingy)
    endelse
        
;    retString = '{OBJ' 
;    OK = thingy->get(name=thisName)
;    if (OK) then retString =retString + '_' + thisName + '}'
    return, retString
  endif
  
  if (ptr_valid(thingy)) then begin 	;shouldn't happen
    retString = '{PTR}' 
;    retString = '{PTR}'  +  format_size(ptr_array=thingy)
    return, retString
  endif

 ; Everything else is STRING or a numeric type.
  if (size(thingy, /tname) EQ 'STRING') then begin
    retString = "'" +  thingy + "'"
;Dumb    retString = "'" +  strcompress(string(thingy), /remove_all) + "'"
  endif else begin
    retString = strcompress(string(thingy), /remove_all) 
  endelse
  return, retString
  
end		; whatsIt
